#############################
#
#          FVJeux
#
# Copyright 2007,2008,2009 Newmagic
#
#    This file is part of FVJeux.
#
#    You can redistribute and/or modify
#    this software under the terms of the
#    Creative Commons  Attribution-NonCommercial-ShareAlike 3.0 Legal Code
#
#    See COPYING file(s) join to the distribution and/or
#    http://creativecommons.org/licenses/by-nc-sa/3.0/legalcode
#
#############################

set PARAM(rep) [info script]
set PARAM(rep) [file dirname $PARAM(rep)]
cd $PARAM(rep)

set PARAM(nomAppli) "FVJeux"
set PARAM(nomLongAppli) "Fates vos Jeux !"
set PARAM(verAppli) "v0.12"
set PARAM(dateVer) "23/04/2009"
set PARAM(vitesse) 0

source [file join "Lib" "Lib_fichiers.tcl"]
#logInfo "dbut du chargement..."

utiliseLibrairie "outils"

utiliseLibrairie "hasard"

source "$PARAM(nomAppli)\_interface.tcl"
#logDebug "fin du chargement : interface appli"

utiliseLibrairie "highscores"

utiliseLibrairie "statistiques"

set REP_JEUX "Jeux"
set REP_CHALLENGES "Challenges"
set REP_STATS [cheminComplet "Statistiques"]
creerRep $REP_STATS

set joueurs(1,humain) true
set joueurs(1,score) 200 ;# par dfaut
set joueurs(1,nom) "NouvJoueur"
catch {set joueurs(1,nom) "[lireFichier [cheminComplet "DernierJoueur.txt"]]"}

global bloque
set bloque false

proc perdre {montant {joueur 1}} {
  global joueurs
  global casino
  global casino_AJoue

  if {$casino} {
    set casino_AJoue true
  }
  set joueurs($joueur,score) [expr {$joueurs($joueur,score) - $montant}]
  majAfficheScore
}

proc gagner {montant {joueur 1}} {
  global joueurs
  global casino
  global casino_AJoue

  if {$casino} {
    set casino_AJoue true
  }
  set joueurs($joueur,score) [expr {$joueurs($joueur,score) + $montant}]
  majAfficheScore
}


proc ajouterOutil {nomOutil} {
  ajouterOutilHasard $nomOutil [genererListeFacesOutilHasard [lireFichier [file join "Outils" "$nomOutil\.txt"]]]
}


proc demandePrenom {} {
  global joueurs
  global couleurs
  set saisie [inputBox [list " Quel est votre nom ? "] "Nouveau joueur" [list "$joueurs(1,nom)"] $couleurs(DemandesFond)]
  if {[string trim $saisie " "] != ""} {
    set joueurs(1,nom) $saisie
    # On le sauvgarde dans le fichier du Dernier Joueur :
    ecrireFichier [cheminComplet "DernierJoueur.txt"] "$joueurs(1,nom)" 1
  } else {
    set saisie ""
  }
  return $saisie
}

proc demandePrenomEtScore {{libelleScore "Score de dpart"} {titre "Nouveau joueur"}} {
  global joueurs
  global couleurs

  set saisie [inputBox [list " Votre nom : " " $libelleScore : "] \
                       "$titre" \
                       [list "$joueurs(1,nom)" "$joueurs(1,score)"] \
                       $couleurs(DemandesFond)]
  if {[string trim $saisie " "] != ""} {
    set nom [lindex $saisie 0]
    set score [lindex $saisie 1]
    if {[string trim $nom " "] != ""} {
      set joueurs(1,nom) $nom
      # On le sauvegarde dans le fichier du Dernier Joueur :
      ecrireFichier [cheminComplet "DernierJoueur.txt"] "$joueurs(1,nom)" 1
      if {[string trim $score " "] != ""} {
        set msgErrTmp [testerFormatEntier $score "L'information \"$libelleScore\""]
        if {$msgErrTmp == ""} {
          set joueurs(1,score) [expr {0 + $score}]
          return "ok"
        } else {
          msgBox "$msgErrTmp" "$libelleScore"
          return ""
        }
      } else {
        msgBox "Il manque l'information \"$libelleScore\"..." "$libelleScore"
        return ""
      }
    } else {
      return ""
    }
  } else {
    return ""
  }
}

proc Entrainement {nomJeu} {
  global challenge
  global casino
  global joueurs
  global couleurs

  set saisie [demandePrenomEtScore "Montant en banque"]
  if {$saisie != ""} {
      set challenge false
      set casino false
      jouerA $nomJeu
  } else {
    msgBox "Vous devez indiquer votre nom."
  }
}

proc jouerA {nomJeu} {
  global REP_JEUX
  global REP_STATS

  initOutilsHasard
  source [file join $REP_JEUX "Jeux_Init.tcl"]
  chargerStats [file join $REP_STATS "Stats_$nomJeu\.txt"]
  source [file join $REP_JEUX "Jeu_$nomJeu\.tcl"]
  initAfficheJeu
  commencerJeu
}

set lstJeuxChallenge [list] 
set indJeuChallengeCourant -1
set challenge false
set challengeNom ""
set challengeDelaiAttente 0
proc Challenge_Commencer {nomChallenge} {
  global lstJeuxChallenge
  global indJeuChallengeCourant
  global casino
  global challenge
  global challengeNom
  global joueurs
  global couleurs
  global REP_CHALLENGES

  set saisie [demandePrenom]
  if {$saisie != ""} {
    set challengeNom $nomChallenge
    set lstJeuxChallenge [split [lireFichier [file join $REP_CHALLENGES "Challenge_$nomChallenge.txt"]]]
    set montantDepart [lindex $lstJeuxChallenge 0]
    set joueurs(1,score) "$montantDepart"
    if {$montantDepart != "0"} {
      msgBox "$joueurs(1,nom), vous commencez avec $joueurs(1,score) euros. Bonne chance !" "Challenge"
    }
    set indJeuChallengeCourant 0
    set challenge true
    set casino false
    Challenge_JeuSuivant
  }
}

proc Challenge_JeuSuivant {} {
  global lstJeuxChallenge
  global indJeuChallengeCourant
  global joueurs
  global challengeNom
  global challengeDelaiAttente
  global bloque

  if {$indJeuChallengeCourant != 0} {
    pause $challengeDelaiAttente
  } ;# sinon, on est au premier => pas de pause
  set bloque false
  set challengeDelaiAttente 1700 ;#valeur par dfaut
  incr indJeuChallengeCourant
  if {$indJeuChallengeCourant < [llength $lstJeuxChallenge]} {
    jouerA [lindex $lstJeuxChallenge $indJeuChallengeCourant]
    update
  } else {
    msgBox "Challenge termin !" "$challengeNom"
    if {$joueurs(1,score) > 0} {
      chargerHighScores [cheminComplet "highscores_Challenge_$challengeNom\.txt"]
      set nouveau [nouveauHighScore? $joueurs(1,nom) $joueurs(1,score) ""]
      if {$nouveau >= 1} {
        if {$nouveau == 1} {
          msgBox "Bravo ! Vous tes le meilleur joueur !" "Meilleur joueur"
        } else {
          msgBox "Vous entrez dans les meilleurs scores ! Flicitations !" "Meilleurs scores"
        }
        afficherHighScores "Challenge $challengeNom"
      }
    }
    afficherFrame frmMenuPrincipal
  }
}

set casino false
set casinoSommeEntree ""
proc Casino_MajSalles {} {
  global casinoSalles
  global casinoNomSalle
  global casinoCouleursSalle

  unset casinoSalles
  unset casinoNomSalle
  unset casinoCouleursSalle

  set listeSalles [listeFic "*.txt" "Casino"]
  foreach salle $listeSalles {
    set infosSalle [split [lireFichier [file join "Casino" $salle]] "\n"]
    set idSalle [string range $salle 0 [expr {[string first "\." $salle]-1}]]
    set nomSalle [lindex $infosSalle 0]
    set couleurFondSalle [lindex $infosSalle 1]
    set couleurPoliceSalle [lindex $infosSalle 2]
    set listeJeuxSalle [lrange $infosSalle 3 end]

    set casinoSalles($idSalle) $listeJeuxSalle
    set casinoNomSalle($idSalle) "$nomSalle"
    set casinoCouleursSalle($idSalle,fond) $couleurFondSalle
    set casinoCouleursSalle($idSalle,police) $couleurPoliceSalle
  }
  majAfficheCasino
}
set casinoSalles(idSalle) [list jeux]
set casinoNomSalle(idSalle) "nom complet"
set casinoCouleursSalle(idSalle) "couleurs"

Casino_MajSalles

set salleCourante ""

proc Casino_Entrer {} {
  global casino
  global challenge
  global joueurs
  global couleurs
  global salleCourante
  global casinoSommeEntree
  global casino_AJoue

  if {! $casino} {
    Casino_MajSalles
  }
  majNomsEtScores .frmCasinoEntree.lblSommePoche
  afficherFrame frmCasinoEntree
  set salleCourante ""
  if {! $casino} {
    set saisie [demandePrenomEtScore "Argent en poche" "Dbut de partie"]
    if {$saisie != ""} {
      if {[string trim $joueurs(1,score) " "] <= 0} {
        set joueurs(1,score) ""
      }
      if {[string trim $joueurs(1,score) " "] != ""} {
        majNomsEtScores .frmCasinoEntree.lblSommePoche
        set casinoSommeEntree $joueurs(1,score)
        set challenge false
        set casino true
        set casino_AJoue false
        creerMenuFichier "Menu_Casino.txt"
      } else {
        msgBox "Vous ne pouvez pas entrer dans le casino sans argent..." "Casino"
      }
    }
  }
  if {! $casino} {
    afficherFrame frmMenuPrincipal
  }
}


proc Casino_EntrerDansSalle {idSalle} {
  global casino
  global salleCourante

  if {! $casino} {
    Casino_Entrer
  }
  if {$casino} {
    set salleCourante $idSalle
    majNomsEtScores .frmCasinoSalle$idSalle.lblSommePoche
    afficherFrame frmCasinoSalle$idSalle
  }
}

proc Casino_QuitterJeu {} {
  global casino
  global salleCourante

  if {$casino && $salleCourante != ""} {
    Casino_EntrerDansSalle $salleCourante
  }
}

proc Casino {nomJeu} {
  global casino

  if {! $casino} {
    Casino_Entrer
  }
  if {$casino} {
     jouerA $nomJeu
  }
}


proc Casino_Quitter {} {
  global casino
  global joueurs
  global casinoSommeEntree
  global casino_AJoue
  global PARAM

  if {$casino} {
    set casino false
    if {$joueurs(1,score) > 0 && $casino_AJoue} {
      chargerHighScores [cheminComplet "highscores_Casino.txt"]
      set gain [expr {$joueurs(1,score) - $casinoSommeEntree}]
      if {$gain > 0} {
        set nouveau [nouveauHighScore? $joueurs(1,nom) $gain "$joueurs(1,score)"]
        if {$nouveau >= 1} {
          if {$nouveau == 1} {
            msgBox "Bravo ! Vous tes le meilleur joueur !" "Meilleur joueur"
          } else {
            msgBox "Vous entrez dans les meilleurs scores ! Flicitations !" "Meilleurs scores"
          }
          afficherHighScores "Casino"
        }
      }
    }
    creerMenuFichier "$PARAM(fichierMenu)"
    afficherFrame frmMenuPrincipal
  }
}

proc afficherHighScoresChallenge {nomChallenge} {
  chargerHighScores [cheminComplet "highscores_Challenge_$nomChallenge\.txt"]
  afficherHighScores "Challenge $nomChallenge"
}

proc afficherHighScoresCasino {} {
  chargerHighScores [cheminComplet "highscores_Casino.txt"]
  afficherHighScores "Casino"
}


proc chargerPartie {} {
  msgBox "Charger partie !"
}

proc continuerPartie {} {
  msgBox "Continuer partie !"
}

proc sauverPartie {} {
  msgBox "Sauver partie !"
}

proc highScores {} {
  msgBox "Meilleurs Scores !"
}

proc lblEsperanceMathematique {} {
  msgBox "Veuillez d'abord commencer un jeu..." "Esprance mathmatique"
}

proc lblAideJeu {} {
  msgBox "Veuillez d'abord commencer un jeu..." "Aide"
}

afficherFrame frmMenuPrincipal
#logInfo "fin du chargement total"
# msgBox "[listeFic "*.txt"]"
