#############################
#
#          FVJeux
#
# Copyright 2007,2008,2009 Newmagic
#
#    This file is part of FVJeux.
#
#    You can redistribute and/or modify
#    this software under the terms of the
#    Creative Commons  Attribution-NonCommercial-ShareAlike 3.0 Legal Code
#
#    See COPYING file(s) join to the distribution and/or
#    http://creativecommons.org/licenses/by-nc-sa/3.0/legalcode
#
#############################

#logDebug "Dbut interface appli"
utiliseLibrairie "interface"
#logDebug "Lib_interface charge !"

if {$PARAM(machine) == "PPC"} {
  refermerClavier ;# "referme" le clavier, au cas o...
}

# Valeurs par dfaut :
set PARAM(hauteur) 640
set PARAM(largeur) 480
set PARAM(fichierMenu) "Menu.txt"
set PARAM(msgAccueil) "$PARAM(nomLongAppli)"
set PARAM(unite) ""
#set PARAM(taillePoliceBase) 6
set couleurs(FondFenetre) "#000000"
set couleurs(DemandesFond) "#ffffff"
set couleurs(Police) "#ffff00"
set polices(Titre) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 8}] -weight bold]
set polices(Normale) [font create -family Courier -size $PARAM(taillePoliceBase) -weight bold]
set polices(DialogBox) [font create -family Courier -size $PARAM(taillePoliceBase)]

set couleurs(FondFenetreCasino) "#e80000"
set couleurs(PoliceCasino) "#ffff55"
set polices(TitreCasino) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 4}] -weight bold]
set polices(Casino) [font create -family Courier -size $PARAM(taillePoliceBase) -weight bold]

array set imagesFaces [list]

# Puis excution du fichier des paramtres, selon la machine :
source "initParamsInterface_$PARAM(machine)\.ini"
#source "initParamsInterface_PPC.ini"

initFenetre $PARAM(nomAppli) $PARAM(largeur) $PARAM(hauteur)
afficherFrmAttente
update

utiliseLibrairie "images"


### Menu de l'application
#majMsgAttente "Menu de l'application"
#logDebug "Cration du menu..."
creerMenuFichier "$PARAM(fichierMenu)"
#logDebug "Menu cr !"

#majMsgAttente "Cration des crans"
frame .frmMenuPrincipal -background $couleurs(FondFenetre)
ajouterLigneVideHaut frmMenuPrincipal $couleurs(FondFenetre)
ajouterLigneVideBas frmMenuPrincipal $couleurs(FondFenetre)
ajouterLabel frmMenuPrincipal lblMessage $PARAM(msgAccueil) $polices(Titre)  $couleurs(FondFenetre) $couleurs(Police) ""


proc majNomsEtScores {idWidget} {
  global joueurs
  global PARAM
  $idWidget configure -text "$joueurs(1,nom) : $joueurs(1,score) $PARAM(unite)"
}

proc majResultat {nouvRes} {
  .frmJeu.lblResultat configure -text "$nouvRes"
}

proc initAfficheJeu {} {
}

proc majAfficheJeu {} {
}

proc majAfficheScore {} {
}

### Affichage des diffrentes salles du Casino :

proc majAfficheCasino {} {
  global couleurs
  global polices
  global casinoSalles
  global casinoNomSalle
  global casinoCouleursSalle

  destroy .frmCasinoEntree
  frame .frmCasinoEntree -background $couleurs(FondFenetreCasino)
  ajouterLigneVideHaut frmCasinoEntree $couleurs(FondFenetreCasino)
  ajouterLigneVideBas frmCasinoEntree $couleurs(FondFenetreCasino)
  ajouterLabel frmCasinoEntree lblMessage "Bienvenue dans le Casino !" $polices(TitreCasino) $couleurs(FondFenetreCasino) $couleurs(PoliceCasino) ""
  ajouterFrame frmCasinoEntree frmVideApresTitre $couleurs(FondFenetreCasino)
  ajouterLabel frmCasinoEntree lblExplChoixSalle "Choisissez la salle dans laquelle\nvous dsirez jouer :" $polices(Casino)  $couleurs(FondFenetreCasino) $couleurs(PoliceCasino) ""
  ajouterFrame frmCasinoEntree frmVideAvantSalles $couleurs(FondFenetreCasino)

  foreach salle [lsort [array names casinoSalles]] {
    ajouterBoutton frmCasinoEntree cmdSalle$salle "$casinoNomSalle($salle)" "Casino_EntrerDansSalle $salle"
    .frmCasinoEntree.cmdSalle$salle configure -foreground $couleurs(PoliceCasino) \
         -activeforeground $couleurs(PoliceCasino) \
         -background $couleurs(FondFenetreCasino) \
         -activebackground $couleurs(FondFenetreCasino) \
         -font $polices(Casino)
    destroy .frmCasinoSalle$salle
    frame .frmCasinoSalle$salle -background $casinoCouleursSalle($salle,fond)
    ajouterLigneVideHaut frmCasinoSalle$salle $casinoCouleursSalle($salle,fond)
    ajouterLigneVideBas frmCasinoSalle$salle $casinoCouleursSalle($salle,fond)
    ajouterLabel frmCasinoSalle$salle lblMessage "$casinoNomSalle($salle)" $polices(TitreCasino) $casinoCouleursSalle($salle,fond) $casinoCouleursSalle($salle,police) ""
    ajouterFrame frmCasinoSalle$salle frmVideApresTitre $casinoCouleursSalle($salle,fond)
    ajouterLabel frmCasinoSalle$salle lblExplChoixJeu "A quel jeu voulez-vous jouer ?" $polices(Casino) $casinoCouleursSalle($salle,fond) $casinoCouleursSalle($salle,police) ""
    ajouterFrame frmCasinoSalle$salle frmVideAvantJeux $casinoCouleursSalle($salle,fond)
    foreach {idJeu titreJeu} $casinoSalles($salle) {
      ajouterBoutton frmCasinoSalle$salle cmdJeu$idJeu "$titreJeu" "Casino $idJeu"
      .frmCasinoSalle$salle.cmdJeu$idJeu configure -foreground $casinoCouleursSalle($salle,police) \
         -activeforeground $casinoCouleursSalle($salle,police) \
         -background $casinoCouleursSalle($salle,fond) \
         -activebackground $casinoCouleursSalle($salle,fond) \
         -font $polices(Casino)
    }
    ajouterFrame frmCasinoSalle$salle frmVideApresJeux $casinoCouleursSalle($salle,fond)
    ajouterBoutton frmCasinoSalle$salle cmdRetour "Retourner dans le Hall" "Casino_Entrer" "left"
    .frmCasinoSalle$salle.cmdRetour configure -foreground $casinoCouleursSalle($salle,police) \
         -activeforeground $casinoCouleursSalle($salle,police) \
         -background $casinoCouleursSalle($salle,fond) \
         -activebackground $casinoCouleursSalle($salle,fond) \
         -font $polices(Casino)
    ajouterLabel frmCasinoSalle$salle lblSommePoche "" $polices(Casino) $casinoCouleursSalle($salle,fond) $casinoCouleursSalle($salle,police) "right"
    majNomsEtScores .frmCasinoSalle$salle.lblSommePoche
  }

  ajouterFrame frmCasinoEntree frmVideApresSalles $couleurs(FondFenetreCasino)
  ajouterBoutton frmCasinoEntree cmdQuitter "Sortir du casino" "Casino_Quitter" "left"
  .frmCasinoEntree.cmdQuitter configure -foreground $couleurs(PoliceCasino) \
         -activeforeground $couleurs(PoliceCasino) \
         -background $couleurs(FondFenetreCasino) \
         -activebackground $couleurs(FondFenetreCasino) \
         -font $polices(Casino)
  ajouterLabel frmCasinoEntree lblSommePoche "" $polices(Casino) $couleurs(FondFenetreCasino) "#ffffff" "right"
  majNomsEtScores .frmCasinoEntree.lblSommePoche
}
