global REP_JEUX
global PARAM
source [file join $REP_JEUX "Jeux_Grille.tcl"]

global couleurs
global polices
global PARAM

global casinoCouleursSalle
set idSalle MachinesSous

set couleurs(PoliceTitreJeu) $casinoCouleursSalle($idSalle,police)
set couleurs(PoliceScoresJeu) "#ffffff"
set couleurs(FondFenetreJeu) $casinoCouleursSalle($idSalle,fond)
set couleurs(FondOutilSelectionne) "#007700"
set couleurs(FondOutilNonSelectionne) $couleurs(FondFenetreJeu) ;#"#FFFFFF"
#set polices(TitreJeu) [font create -family Courier -size [expr $PARAM(taillePoliceBase) + 4] -weight bold -underline true]
#set polices(ScoresJeu) [font create -family Courier -size $PARAM(taillePoliceBase) -slant italic]


global nbOutils
set nbOutils 5

#for {set i 1} {$i <= $nbOutils} {incr i} {
  ajouterOutil "52Cartes"
#}

global nbCoupsMax
set nbCoupsMax 2
global carMarqueCoup
set carMarqueCoup "X"

global nbTours
set nbTours 1

global imagesFaces
global listeOutilsHasard
foreach face $listeOutilsHasard(1,faces) {
  set imagesFaces($face) [getImageFichier [file join "Img" "carte$face.png"]]
}
set imagesFaces() [getImageFichier [file join "Img" "carteVierge.png"]]

global titreJeu
set titreJeu "Vido Poker"

global nomActionTirage
set nomActionTirage "Tirer le manche"

global montantPerd
set montantPerd 2

global labelExplMises
set labelExplMises "\n$montantPerd $PARAM(unite) la mise.\nRemporte la somme\nindique dans la grille."

global cocheGrilleAuto
set cocheGrilleAuto true

global grille
creerGrilleFichier [file join $REP_JEUX "Jeu_VideoPoker_Grille.txt"]

proc cocheGrilleAuto {} {
  global grille
  global nbCoups
  global nbCoupsMax

  set i 1
  set continuer true
  set trouve false
  while {$continuer} {
    if {$grille($i,action) != ""} {
      set grille($i,score) [eval "$grille($i,action)"]
      if {$grille($i,score) > 0} {
        set trouve true
        set continuer false
      }
    }
    if {$continuer} {
      incr i
      if {$i > $grille(taille)} {
        set continuer false
      }
    }
  }
  if {$trouve} {
    choisirCaseGrille $i 2000
  } else {
    choisirCaseGrille -1 1000
  }
#  commencerJeu
  if {$nbCoups >= $nbCoupsMax} {
    set nbCoups 0
  }
}

proc tirer {} {
  global nbOutils
  global outils
  global nbCoups
  global nbCoupsMax
  global cocheGrilleAuto
  global montantPerd
  global carMarqueCoup
  global bloque

  if {!$bloque} {
    set bloque true
    if {$nbCoups < $nbCoupsMax} {
      if {$nbCoups == 0} {
        perdre $montantPerd 1
        majNomsEtScores .frmJeu.frmTirage.lblGains
        incrementerStats "montant investi" false $montantPerd
      }
      incr nbCoups
      for {set i 1} {$i <= $nbOutils} {incr i} {
        if {! $outils($i,garde)} {
          if {"$outils($i,valeur)" != ""} {
            global listeOutilsHasard
            lappend listeOutilsHasard(1,facesRestes) $outils($i,valeur)
          }
        }
      }
      animer
      for {set i 1} {$i <= $nbOutils} {incr i} {
#set lstTirage [list "" AT RT DT VT 10T]
        if {! $outils($i,garde)} {
          set outils($i,valeur) [tirerOutilSansRemise 1] ;#[lindex $lstTirage $i] ;# [tirerOutilSansRemise 1]
          majAfficheJeu $i
#incrementerStats $outils($i,valeur) false
        }
      }
      if {$nbCoupsMax > 1} {
        .frmJeu.frmTirage.frmCoups.lblCoups$nbCoups configure -text "$carMarqueCoup"
        update
      }
  
      if {$nbCoups == $nbCoupsMax && $cocheGrilleAuto} {
        pause 1000
        cocheGrilleAuto
      }
    } else {
      majNomsEtScores .frmJeu.frmTirage.lblGains
    }
    set bloque false
  }
}


proc valeurFace {val} {
  set valeur [string range $val 0 end-1]
  set valeur [string trimleft $valeur "0"]
  if {$valeur == "A"} {
    set valeur 1
  }
  if {$valeur == "V"} {
    set valeur 11
  }
  if {$valeur == "D"} {
    set valeur 12
  }
  if {$valeur == "R"} {
    set valeur 13
  }
  if {$valeur < 10} {
    set valeur "0$valeur"
  }
  return $valeur
}

proc familleFace {faceTiree} {
  global outils
#  set indCarFamille [expr [string length $faceTiree] - 1]
  return [string index $faceTiree end]
}

proc famille {} {
  global nbOutils
  global outils

  set resultat true
  set famillePremier [familleFace $outils(1,valeur)]
  for {set i 2} {$i <= $nbOutils} {incr i} {
    set familleFaceCourante [familleFace $outils($i,valeur)]
    if {$familleFaceCourante != $famillePremier} {
      set resultat false
    }
  }
  return $resultat
}



proc SuiteDe {nbFacesSuite} {
  set listeValeursTriee [listeFacesOrdre]
  if {[string trimleft [lindex $listeValeursTriee 0] "0"] == "1"} {
    # il y a au-moins un as => on rajoute un 14 aprs les ventuels rois
    lappend listeValeursTriee 14
  }
  set continuer true
  set i 0
  set j 1
  set nbSuivent 1
  set nbSuiventMax 1
  while {$continuer} {
    set carte1 [string trimleft [lindex $listeValeursTriee $i] "0"]
    set carte2 [string trimleft [lindex $listeValeursTriee $j] "0"]
#msgBox "$carte1 $carte2"
    if {[expr {$carte2 - $carte1}] == 1} {
      # Elles se suivent !
      incr nbSuivent
      if {$nbSuivent == $nbFacesSuite} {
        if {$nbSuivent > $nbSuiventMax} {
          set nbSuiventMax $nbSuivent
        }
        set continuer false
      }
    } else {
      # Elles ne se suivent pas...
      if {$nbSuivent > $nbSuiventMax} {
        set nbSuiventMax $nbSuivent
      }
      set nbSuivent 1
    }
    if {$continuer} {
      incr i
      incr j
      if {$j >= [llength $listeValeursTriee]} {
        set continuer false
        set nbSuivent 1
      }
    }
  }
  if {$nbSuiventMax >= $nbFacesSuite} {
    return true
  } else {
    return false
  }
}

proc contient {val} {
  set trouve false
  foreach face [listeFacesOrdre] {
    if {$face == $val} {
      set trouve true
    } else {
    msgBox "$face != $val"
    }
  }
  return $trouve
}

proc animerAuHasard {delai nbIter} {
  global nbOutils
  global outils

  for {set i 0} {$i < $nbIter} {incr i} {
    for {set j 1} {$j <= $nbOutils} {incr j} {
      if {! $outils($j,garde)} {
        set outils($j,valeur) [tirerOutilAvecRemise 1]
        majAfficheJeu $j
      }
    }
update
    pause $delai
  }
}

proc animer {} {
  set nbAnim [expr {int(rand() * 4) + 6}]
  animerAuHasard 70 $nbAnim
}

proc lblAideJeu {} {
  global nbCoupsMax
  global montantPerd
  global PARAM

  msgBox \
"But du jeu : Obtenir la meilleure combinaison pour gagner le plus de points.

Principe : Tirez sur le manche et voyez si la chance vous sourit !

Rapports : jouez $montantPerd $PARAM(unite) ; \
remportez le gain correspondant !" "Aide"
}
