global REP_JEUX
global PARAM
source [file join $REP_JEUX "Jeux_Grille.tcl"]

global couleurs
global polices
global PARAM

global casinoCouleursSalle
set idSalle MachinesSous

set couleurs(PoliceTitreJeu) $casinoCouleursSalle($idSalle,police)
set couleurs(PoliceScoresJeu) "#ffffff"
set couleurs(FondFenetreJeu) $casinoCouleursSalle($idSalle,fond)
set couleurs(FondOutilSelectionne) "#ffffff"
set couleurs(FondOutilNonSelectionne) $couleurs(FondFenetreJeu) ;#"#FFFFFF"
set polices(TitreJeu) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 4}] -weight bold -underline true]
set polices(ScoresJeu) [font create -family Courier -size $PARAM(taillePoliceBase) -slant italic]


global nbOutils
set nbOutils 0

for {set i 1} {$i <= $nbOutils} {incr i} {
  ajouterOutil "banditManchot"
}

global debutJeu
set debutJeu true

global nbCoupsMax
set nbCoupsMax 1

global nbTours
set nbTours 1

global titreJeu
set titreJeu "Bandit manchot"

global nomActionTirage
set nomActionTirage "Tirer le manche"

global montantPerd
set montantPerd 5

global labelExplMises
set labelExplMises "\n$montantPerd $PARAM(unite) la mise.\nRemporte la somme\nindique dans la grille."

global cocheGrilleAuto
set cocheGrilleAuto true

global grille
creerGrilleFichier [file join $REP_JEUX "Jeu_BanditManchot_Grille.txt"]

proc cocheGrilleAuto {} {
  global grille
  global nbCoups
  global nbCoupsMax

  set i 1
  set continuer true
  set trouve false
  while {$continuer} {
    if {$grille($i,action) != ""} {
      set grille($i,score) [eval "$grille($i,action)"]
      if {$grille($i,score) > 0} {
        set trouve true
        set continuer false
      }
    }
    if {$continuer} {
      incr i
      if {$i > $grille(taille)} {
        set continuer false
      }
    }
  }
  if $trouve {
    choisirCaseGrille $i 1000
  } else {
    choisirCaseGrille -1
  }
#  commencerJeu
  if {$nbCoups >= $nbCoupsMax} {
    set nbCoups 0
  }

}


proc commencerJeu {} {
  global nbOutilsHasard
  global outils
  global debutJeu
  global listeOutilsHasard
  global bloque
  
  set bloque false
  set listeFaces $listeOutilsHasard(1,faces)
  set nbFaces [llength $listeFaces]

  if {$debutJeu} {
    for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
      # On initialise tous les outils avec une valeur au hasard, pour arriver sur le jeu avec dj des images
      set outils($indOutil,indiceFace) [expr {int(rand() * $nbFaces)}]
            set outils($indOutil,valeur) [lindex $listeFaces $outils($indOutil,indiceFace)]
    }
    set debutJeu false
  }
  majAfficheJeu
}


proc animerALaSuite {delai nbAnim} {
  global nbOutilsHasard
  global outils
  global vitesseAffichage
  global listeOutilsHasard

effacerPointsGrille
  set nbAnimBoucle $nbAnim
  set delaiBoucle $delai

  set listeFaces $listeOutilsHasard(1,faces)
  set nbFaces [llength $listeFaces]
  for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
#    remiseTotaleOutilHasard $indOutil
    # pour chaque face,
    if {$vitesseAffichage != 0} {
      for {set indAnim 1} {$indAnim <= $nbAnimBoucle} {incr indAnim} {
        # on anime tous les outils >= $indOutil
        for {set indOutilAnim $indOutil} {$indOutilAnim <= $nbOutilsHasard} {incr indOutilAnim} {
          set outils($indOutilAnim,indiceFace) [expr {$outils($indOutilAnim,indiceFace) + 1}]
          if {$outils($indOutilAnim,indiceFace) >= $nbFaces} {
            set outils($indOutilAnim,indiceFace) 0
          }
          set outils($indOutilAnim,valeur) [lindex $listeFaces $outils($indOutilAnim,indiceFace)]
          majAfficheJeu $indOutilAnim
        }
        pause $delaiBoucle
      }
    }
    # puis on tire cette face :
#      set outils($indOutil,valeur) [tirerOutilAvecRemise $indOutil]
#      majAfficheJeu $indOutil
    incr delaiBoucle 10 ;#$delai
    update
  }
}

proc animerAuHasard {delai nbAnim} {
  global nbOutilsHasard
  global outils
  global vitesseAffichage

  effacerPointsGrille
  set nbAnimBoucle $nbAnim
  set delaiBoucle $delai

  for {set indOutil 1} {$indOutil <= $nbOutilsHasard} {incr indOutil} {
#    remiseTotaleOutilHasard $indOutil
      # pour chaque face,
      if {$vitesseAffichage != 0} {
        for {set indAnim 1} {$indAnim <= $nbAnimBoucle} {incr indAnim} {
          # on anime tous les outils >= $indOutil
          for {set indOutilAnim $indOutil} {$indOutilAnim <= $nbOutilsHasard} {incr indOutilAnim} {
            set outils($indOutilAnim,valeur) [tirerOutilAvecRemise $indOutilAnim]
            majAfficheJeu $indOutilAnim
          }
          pause $delaiBoucle
        }
      }
      # puis on tire cette face :
      set outils($indOutil,valeur) [tirerOutilAvecRemise $indOutil]
      majAfficheJeu $indOutil
      incr delaiBoucle 10 ;#$delai
    update
  }
}

proc tirer {} {
  global nbOutils
  global outils
  global nbCoups
  global nbCoupsMax
  global cocheGrilleAuto
  global montantPerd
  global bloque

  if {!$bloque} {
    set bloque true
    if {$nbCoups < $nbCoupsMax} {
      if {$nbCoups == 0} {
        perdre $montantPerd 1
        majNomsEtScores .frmJeu.frmTirage.lblGains
        incrementerStats "montant investi" true $montantPerd
      }
      incr nbCoups
      animer
      if {$nbCoups == $nbCoupsMax && $cocheGrilleAuto} {
  #      pause 1000
        cocheGrilleAuto
      }
    } else {
      majNomsEtScores .frmJeu.frmTirage.lblGains
    }
    set bloque false
  }
}

proc famille {} {
  global nbOutils
  global outils

  set resultat true
  set famillePremier [familleFace $outils(1,valeur)]
  for {set i 2} {$i <= $nbOutils} {incr i} {
    set familleFaceCourante [familleFace $outils($i,valeur)]
    if {$familleFaceCourante != $famillePremier} {
      set resultat false
    }
  }
  return $resultat
}

proc familleFace {faceTiree} {
  global outils
#  set indCarFamille [expr [string length $faceTiree] - 1]
  return [string index $faceTiree 0]
}

proc lblAideJeu {} {
  global nbCoupsMax
  global montantPerd
  global PARAM

  msgBox \
"But du jeu : Obtenir la meilleure combinaison pour gagner le plus de points.

Principe : Tirez sur le manche et voyez si la chance vous sourit !

Rapports : jouez $montantPerd $PARAM(unite) ; \
remportez le gain correspondant !" "Aide"
}
