global REP_JEUX
global PARAM
source [file join $REP_JEUX "Jeux_Pari_1_1.tcl"]

global listeFacesPossibles
set listeFacesPossibles [list]

proc correspond {facesMisees faceTiree} {
  msgBox "correspond :  crire !"
  return 0
}

proc lblAvantRes {} {
  return ""
}

proc lblApresRes {} {
  return ""
}

proc lblEsperanceMathematique {} {
  msgBox "Non encore implmente dans Jeux_Pari_1_1_Custom" "Esprance mathmatique"
}

proc lblAideJeu {} {
  msgBox "But du jeu : Parier sur une ou plusieurs faces en esprant remporter le gain." "Aide"
}


proc initAfficheJeu {} {
  global couleurs
  global polices
  global listeOutilsHasard
  global titreJeu
  global nomActionTirage
  global nbFacesMiseesMax
  global montantGagne
  global montantPerd
  global imagesFaces
  global PARAM
global listeFacesPossibles
global montantGagneMax

  destroy .frmJeu
  frame .frmJeu -background $couleurs(FondFenetreJeu)
  ajouterLigneVideHaut frmJeu $couleurs(FondFenetreJeu)
  ajouterLigneVideBas frmJeu $couleurs(FondFenetreJeu)

  ajouterLabel frmJeu lblTitre "$titreJeu" $polices(TitreJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceTitreJeu) "top"
  ajouterFrame frmJeu frmVideApresTitre $couleurs(FondFenetreJeu)

  ajouterLabel frmJeu lblTirage "" $polices(ResultatTirage) $couleurs(FondFenetreJeu) $couleurs(PoliceResultatTirage) ""

  ajouterBoutton frmJeu cmdTirer "$nomActionTirage" {tirer} ""
#  ajouterBoutton frmJeu cmdNew "Recommencer" {commencerJeu} ""

  ajouterFrame frmJeu frmChoix $couleurs(FondFenetreJeu)

  set i 0
  foreach face $listeFacesPossibles {
    button .frmJeu.frmChoix.cmd$i -command "choisir $i" -text "$face"
    grid .frmJeu.frmChoix.cmd$i -column [expr {$i + 1}] -row 1 -padx 1
#ajouterBoutton frmJeu.frmChoix cmdFace "Face" {choisir Face} "right"
    incr i
  }

  ajouterLabel frmJeu lblGains "" $polices(ScoresJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceScoresJeu) bottom

  set labelExplMises "$montantPerd $PARAM(unite) la mise"
  if {$nbFacesMiseesMax > 1} {
    append labelExplMises " ($nbFacesMiseesMax max.)"
  }
  if {$nbFacesMiseesMax <= -1} {
    append labelExplMises " (pas de limite)"
  }
  if {$montantGagneMax == ""} {
    append labelExplMises " ; gagne $montantGagne $PARAM(unite)"
  } else {
    append labelExplMises " ; gagne jusqu' $montantGagneMax $PARAM(unite)"
  }

  ajouterLabel frmJeu lblMises "$labelExplMises" $polices(ScoresJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceScoresJeu) bottom

  pack .frmJeu -expand 1 -fill both

  afficherFrame frmJeu
}

set bloque false
proc commencerJeu {} {
  global couleurs
  global faceTiree
  global bloque

#  set faceMisee ""
  set faceTiree ""
  set bloque false

  majNomsEtScores .frmJeu.lblGains
  majAfficheJeu
}

proc tirer {} {
  global faceTiree
  global facesMisees
  global montantGagne
  global montantPerd
  global titreJeu
  global challenge
  global delaiAvantEfface
  global bloque

  if {! $bloque} {
    set bloque true
    set nbMises [llength $facesMisees]
    if {$nbMises > 0} {
incrementerStats "nb mises" false $nbMises
      set investi [expr {$nbMises * $montantPerd}]
      perdre $investi 1
      majNomsEtScores .frmJeu.lblGains
incrementerStats "montant investi" false $investi
      animer
      tirerFace
      majAfficheJeu false
      if {[correspond $facesMisees $faceTiree] >= 0} {
        # gagn
        gagner $montantGagne 1
        majNomsEtScores .frmJeu.lblGains
incrementerStats "total gains" false $montantGagne
      }
#if {$faceTiree != ""} {
#  incrementerStats $faceTiree
#}
      if {$challenge} {
        Challenge_JeuSuivant
      } else {
        pause $delaiAvantEfface
        commencerJeu
      }
    } else {
      msgBox "Veuillez d'abord miser..." [replaceAll "$titreJeu" "\n" " "]
      set bloque false
    }
  }
}

proc majAfficheJeu {{majMises true}} {
  global facesMisees
  global faceTiree
  global imagesFaces
  global couleurs
  global listeOutilsHasard
  global listeFacesPossibles

  if {$majMises} {
    set i 0
    foreach face $listeFacesPossibles {
      .frmJeu.frmChoix.cmd$i configure -background $couleurs(FondNonSelectionne) -activebackground $couleurs(FondNonSelectionne)
      incr i
    }

    foreach face $facesMisees {
      set indFaceMisee [lsearch $listeFacesPossibles "$face"]
      .frmJeu.frmChoix.cmd$indFaceMisee configure -background $couleurs(FondSelectionne) -activebackground $couleurs(FondSelectionne)
    }
  }

  # On interroge les textes avant l'image
  # Pour plus de modularit dans les jeux hritant
  # (ex : ne pas afficher l'image du gagnant)
  set txtAvant [lblAvantRes]
  set txtApres [lblApresRes]
  set imageFace ""
  catch {set imageFace $imagesFaces($faceTiree)}
  if {$imageFace != ""} {
    .frmJeu.lblTirage configure -image $imageFace -text "$txtAvant$txtApres"
  } else {
    .frmJeu.lblTirage configure -text "$txtAvant$faceTiree$txtApres"
  }
  update
}

proc choisir {indFace} {
  global facesMisees
  global nbFacesMiseesMax
  global couleurs
  global listeOutilsHasard
  global listeFacesPossibles
  global bloque
  
  if {! $bloque} {
    set faceChoisie [lindex $listeFacesPossibles $indFace]
    set indDansMisees [lsearch $facesMisees $faceChoisie]
    if {$indDansMisees >= 0} {
      # existe dj =>  supprimer
      set facesMisees [lreplace $facesMisees $indDansMisees $indDansMisees]
    } else {
      # on doit l'ajouter => on vrifie la taille :
      if {[llength $facesMisees] >= $nbFacesMiseesMax && $nbFacesMiseesMax > 0} {
        # on supprime le premier :
        set facesMisees [lreplace $facesMisees 0 0]
      }
      # on ajoute le nouveau !
      lappend facesMisees $faceChoisie
    }
    majAfficheJeu
  }
}
