global REP_JEUX
global PARAM
#source [file join $REP_JEUX "Jeux_Pari_1_1_Custom.tcl"]
source [file join $REP_JEUX "Jeux_Pari_1_1.tcl"]

global delaiAvantEfface
set delaiAvantEfface 4000

global couleurs
set polices(NomsCoureurs) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) - 1}] -slant italic]
set couleurs(FondCourseJeu) "#ffffa5"
set couleurs(FondClignoteGagnant) "#000000"

global avanceMin
set avanceMin 3
global avanceMax
set avanceMax 10
global delaiAttente
set delaiAttente 150
global marge
set marge 3 ;# % de la largeur
global x_depart
set x_depart [expr {int($marge * $PARAM(largeur) / 100)}]
global longueur_course
set longueur_course [expr {$PARAM(largeur) - 2 * $x_depart}]; #[expr {$PARAM(largeur) - int($PARAM(largeur) * $marge / 100)}]
global largeur_coureurs
set largeur_coureurs 0 ;# inconnue pour l'instant...
global nomsCoureurs
set nomsCoureurs [list]

proc lblAvantRes {} {
  global faceTiree
  global listeFacesPossibles
  global couleurs
  
  if {$faceTiree != ""} {
    # On fait clignoter le gagnant :
    set indiceGagnant [lsearch $listeFacesPossibles $faceTiree]
    set sauvCoul [.frmJeu.frmChoix.cmd$indiceGagnant cget -background]
    
    for {set i 1} {$i <= 3} {incr i} {
      pause 500
      .frmJeu.frmChoix.cmd$indiceGagnant configure -background $couleurs(FondClignoteGagnant)
      pause 500
      .frmJeu.frmChoix.cmd$indiceGagnant configure -background $sauvCoul
    }
    set faceTiree ""
  }
  return "A votre avis, qui va gagner ?\n"
}

proc lblAideJeu {} {
  msgBox "But du jeu : Parier sur un ou plusieurs coureurs en esprant remporter le gain." "Aide"
}


proc initAfficheJeu {} {
  global couleurs
  global polices
  global listeOutilsHasard
  global titreJeu
  global nomActionTirage
  global nbFacesMiseesMax
  global montantGagne
  global montantPerd
  global imagesFaces
  global PARAM
  global nomsCoureurs
  global montantGagneMax

  destroy .frmJeu
  frame .frmJeu -background $couleurs(FondFenetreJeu)
  ajouterLigneVideHaut frmJeu $couleurs(FondFenetreJeu)
  ajouterLigneVideBas frmJeu $couleurs(FondFenetreJeu)

  ajouterFrame frmJeu frmVideAvantTitre $couleurs(FondFenetreJeu)
  ajouterLabel frmJeu lblTitre "$titreJeu" $polices(TitreJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceTitreJeu) "top"
  ajouterFrame frmJeu frmVideApresTitre $couleurs(FondFenetreJeu)

  ajouterLabel frmJeu lblTirage "" $polices(ResultatTirage) $couleurs(FondFenetreJeu) $couleurs(PoliceResultatTirage) ""

  if {$nomActionTirage != ""} {
    ajouterBoutton frmJeu cmdTirer "$nomActionTirage" {initAfficheCourse;tirer} ""
#  ajouterBoutton frmJeu cmdNew "Recommencer" {commencerJeu} ""
  }

  ajouterFrame frmJeu frmChoix $couleurs(FondFenetreJeu)

  set i 0
  foreach face $listeOutilsHasard(1,faces) {
    button .frmJeu.frmChoix.cmd$i -command "choisir $i" -background $couleurs(FondNonSelectionne) -activebackground $couleurs(FondNonSelectionne) \
      -foreground $couleurs(PoliceResultatTirage) -activeforeground $couleurs(PoliceResultatTirage) \
      -font $polices(NomsCoureurs)

    set nomCoureur ""
    catch {set nomCoureur [lindex $nomsCoureurs $i]}
    set imageFace ""
    catch {set imageFace $imagesFaces($face)}
    if {$imageFace != ""} {
      .frmJeu.frmChoix.cmd$i configure -image $imageFace -text "$nomCoureur" -compound top ;# on place l'image en haut
    } else {
      .frmJeu.frmChoix.cmd$i configure -text "$indiceCoureur$face"
    } 
    grid .frmJeu.frmChoix.cmd$i -column [expr {$i + 1}] -row 1 -padx 1 -ipadx 1 -ipady 1
#ajouterBoutton frmJeu.frmChoix cmdFace "Face" {choisir Face} "right"
    incr i
  }

  ajouterLabel frmJeu lblGains "" $polices(ScoresJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceScoresJeu) bottom

  set labelExplMises "$montantPerd $PARAM(unite) la mise"
  if {$nbFacesMiseesMax > 1} {
    append labelExplMises " ($nbFacesMiseesMax max.)"
  }
  if {$nbFacesMiseesMax <= -1} {
    append labelExplMises " (pas de limite)"
  }
  if {$montantGagneMax == ""} {
    append labelExplMises " ; gagne $montantGagne $PARAM(unite)"
  } else {
    append labelExplMises " ; gagne jusqu' $montantGagneMax $PARAM(unite)"
  }

  ajouterLabel frmJeu lblMises "$labelExplMises" $polices(ScoresJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceScoresJeu) bottom

  pack .frmJeu -expand 1 -fill both

  afficherFrame frmJeu
}


proc initAfficheCourse {} {
  global couleurs
  global imagesFaces
  global PARAM
global listeFacesPossibles
global x_depart
global longueur_course
global marge
  global largeur_coureurs

destroy .frmJeu.frmCourse
  frame .frmJeu.frmCourse -background $couleurs(FondCourseJeu)

  set nbCoureurs [llength $listeFacesPossibles]
  set hauteur_coureurs [image height $imagesFaces([lindex $listeFacesPossibles 0])]
  set largeur_coureurs [image width $imagesFaces([lindex $listeFacesPossibles 0])]

set longueur_course [expr {$PARAM(largeur) - $largeur_coureurs}]

  set hauteur_frame [expr {(($hauteur_coureurs + $marge) * $nbCoureurs) + $marge}]
  .frmJeu.frmVideAvantTitre configure -height $hauteur_frame
  place .frmJeu.frmCourse -x $x_depart -y 50 -width $longueur_course -height $hauteur_frame

  set i 0
  foreach face $listeFacesPossibles {
    # On affiche le coureur :
    incr i
    label .frmJeu.frmCourse.lblCoureur$i -text "" -image $imagesFaces($face) -background $couleurs(FondCourseJeu)
    place .frmJeu.frmCourse.lblCoureur$i -x 0 -y [expr {0 + $marge + ($i - 1) * ($hauteur_coureurs + $marge)}]
  }
}

proc commencerJeu {} {
  global couleurs
  global faceTiree
  global bloque

#  set faceMisee ""
  set faceTiree ""
  set bloque false

  majNomsEtScores .frmJeu.lblGains
  majAfficheJeu
  initAfficheCourse
}

proc tirerFace {} {
  # On ne fait rien : la face est "tire" durant l'animation !
}


proc animer {} {
  global listeFacesPossibles
  global PARAM
  global faceTiree
  global frmCourante
  global avanceMin
  global avanceMax
  global delaiAttente
  global longueur_course
  global largeur_coureurs

  # On fait avancer les coureurs un  un jusqu' ce que l'un d'eux franchisse la ligne d'arrive :
  # nombre de coureurs = taille de la liste des faces possibles
  set nbCoureurs [llength $listeFacesPossibles]
  set coureurGagnant -1
  set continuer true
  
  # On rcupre les coordonnes actuelles :
  for {set i 1} {$i <= $nbCoureurs} {incr i} {
    foreach {info valeur} [place info .frmJeu.frmCourse.lblCoureur$i] {
      if {$info == "-x"} {
        set x_coureur($i) $valeur
      }
      if {$info == "-y"} {
        set y_coureur($i) $valeur
      }
    }
  }

  while {$continuer} {
    for {set i 1} {$i <= $nbCoureurs} {incr i} {
      set x_coureur($i) [expr {$x_coureur($i) + int(($avanceMax - $avanceMin + 1) * rand()) + $avanceMin}]
      place .frmJeu.frmCourse.lblCoureur$i -x $x_coureur($i) -y $y_coureur($i)
      if {$x_coureur($i) >= [expr {$longueur_course - $largeur_coureurs}]} {
        set continuer false
        set coureurGagnant $i
      }
    }
    update
    pause $delaiAttente
    if {$frmCourante != "frmJeu"} {
      set continuer false
    }
  }
  if {$frmCourante == "frmJeu"} {
    for {set i 1} {$i <= $nbCoureurs} {incr i} {
      if {$x_coureur($i) > $x_coureur($coureurGagnant)} {
        set coureurGagnant $i
      }
    }
    set faceTiree [lindex $listeFacesPossibles [expr {$coureurGagnant - 1}]]
  }
}

