global REP_JEUX
global PARAM
source [file join $REP_JEUX "Jeux_Pari_1_1.tcl"]

global couleurs
global polices

set couleurs(PoliceTitreJeu) "#ffff00"
set couleurs(PoliceScoresJeu) "#ffffff"
set couleurs(PoliceResultatTirage) "#ffffff"
set couleurs(FondFenetreJeu) "#007700"
set couleurs(FondSelectionne) "#ffff00"
set couleurs(FondNonSelectionne) $couleurs(FondSelectionne)
set polices(TitreJeu) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 6}] -weight bold -underline true]
set polices(ScoresJeu) [font create -family Courier -size $PARAM(taillePoliceBase) -slant italic]
set polices(ResultatTirage) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 2}] -weight bold]


global titreJeu
set titreJeu "!!! Titre !!!"

global nomActionTirage
set nomActionTirage ""

global facesMisees
set facesMisees [list "pourEM"]

global facesGagnantes
set facesGagnantes [list]

global nbFacesMiseesMax
set nbFacesMiseesMax 1

global faceTiree
set faceTiree ""

global imagesFaces
catch {unset imagesFaces}
array set imagesFaces [list]

global imageDos
set imageDos ""

global imagesFacesRetournees
catch {unset imagesFacesRetournees}
array set imagesFacesRetournees [list]

global faceDos
set faceDos ""

global montantGagne
global montantPerd
set montantGagne 1
set montantPerd 1

proc montantGagne {faceTiree} {
  global montantGagne
  global facesGagnantes

  if {[lsearch $facesGagnantes $faceTiree] >= 0} {
    return $montantGagne
  } else {
    return 0
  }
}

global delaiRetourneTous
set delaiRetourneTous 500

global delaiAvantEfface
set delaiAvantEfface 1000

global dejaJoue
set dejaJoue false

proc lblAvantRes {} {
  return ""
}

proc lblApresRes {} {
  return ""
}

proc lblAideJeu {} {
  msgBox "But du jeu : Retrouver la face gagnante." "Aide"
}

proc lblEsperanceMathematique {} {
  global listeOutilsHasard
  global facesMisees
  global montantGagne
  global montantPerd
  global titreJeu
  global PARAM

  set EM 0
foreach face $listeOutilsHasard(1,faces) {
  incr EM [expr {0 + [montantGagne $face] - $montantPerd}]
}
  set titre [replaceAll "$titreJeu" "\n" " "]
  set labelEM "Dans \"$titre\",\nEM = $EM $PARAM(unite)"
  msgBox $labelEM "Esprance mathmatique"
}

proc commencerJeu {} {
  global couleurs
  global faceTiree
  global imagesFacesRetournees
  global imagesFaces
  global imageDos
  global listeOutilsHasard
  global dejaJoue
  global bloque
  
  set bloque false
  set dejaJoue false

  catch {unset imagesFaces}
  foreach face $listeOutilsHasard(1,faces) {
    set imagesFaces($face) $imageDos
  }

  remiseTotaleOutilHasard
#  set faceMisee ""
  set faceTiree ""

.frmJeu.lblTirage configure -text "[lblAvantRes][lblApresRes]"

  majNomsEtScores .frmJeu.lblGains
  majAfficheJeu
}

proc majAfficheJeu {{indFace -1} {face ""}} {
  global imagesFaces
  global listeOutilsHasard

  if {$indFace >= 0} {
    if {$face == ""} {
      set face [lindex $listeOutilsHasard(1,faces) $indFace]
    }
    set imageFace ""
    catch {set imageFace $imagesFaces($face)}
    if {$imageFace != ""} {
      .frmJeu.frmChoix.cmd$indFace configure -image "$imageFace"
    } else {
      .frmJeu.frmChoix.cmd$indFace configure -text "$face"
    }
    update
  } else {
    for {set i 0} {$i < [llength $listeOutilsHasard(1,faces)]} {incr i} {
      majAfficheJeu $i
    }
  }
}

proc tirer {} {
}

proc animer {} {
}

proc choisir {indFace} {
  global listeOutilsHasard
  global imagesFacesRetournees
  global imagesFaces
  global facesGagnantes
  global montantPerd
  global montantGagne
  global challenge
  global delaiAvantEfface
global delaiRetourneTous
  global dejaJoue

  if {!$dejaJoue} {
    set dejaJoue true
    # on tire une face au hasard :
    perdre $montantPerd 1
    majNomsEtScores .frmJeu.lblGains
    incrementerStats "montant investi" false $montantPerd
    set faceTiree [tirerOutilSansRemise]
    catch {set imagesFaces($faceTiree) $imagesFacesRetournees($faceTiree)}
    majAfficheJeu $indFace $faceTiree
    if {[lsearch $facesGagnantes $faceTiree] >= 0} {
      # gagn
      gagner [montantGagne $faceTiree] 1
      majNomsEtScores .frmJeu.lblGains
incrementerStats "total gains" false $montantGagne
    }
incrementerStats "$faceTiree en [expr {1 + $indFace}]"
    # on retourne les autres cartes :
    pause $delaiAvantEfface
    for {set i 0} {$i < [llength $listeOutilsHasard(1,faces)]} {incr i} {
      if {$i != $indFace} {
        set faceTireeTmp [tirerOutilSansRemise]
incrementerStats "$faceTireeTmp en [expr {1 + $i}]"
        catch {set imagesFaces($faceTireeTmp) $imagesFacesRetournees($faceTireeTmp)}
        majAfficheJeu $i $faceTireeTmp
        pause $delaiRetourneTous
      }
    }

    if {$challenge} {
      Challenge_JeuSuivant
    } else {
      pause $delaiAvantEfface
      commencerJeu
    }
  }
}
