global couleurs
global polices

set couleurs(PoliceTitreJeu) "#ffff00"
set couleurs(PoliceScoresJeu) "#ffffff"
set couleurs(PolicePlombs) "#ffffff"
set couleurs(FondFenetreJeu) "#007700"
set couleurs(FondZoneTir) "#000000"
set polices(TitreJeu) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 6}] -weight bold -underline true]
set polices(Plombs) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) - 1}]]
set polices(ScoresJeu) $polices(Plombs)


global titreJeu
set titreJeu "!!! Titre !!!"

global lblExplique
set lblExplique "Explication ???"

# taille de la zone de tir
global TAILLE
set TAILLE 0
set refTaille $PARAM(largeur)
if {$PARAM(hauteur) < $refTaille} {
  set refTaille $PARAM(hauteur)
}
set TAILLE [expr {int($refTaille / 2)}]

global nbPlombsRestants
set nbPlombs ""
catch {set nbPlombs $nbPlombsRestants}
if {$nbPlombs == ""} {
  set nbPlombsRestants 0
}

global jeuEnCours
set jeuEnCours false
 
global listePlombsAchetablesNbEtPrix
set listePlombsAchetablesNbEtPrix [list]

global imgViseur
set imgViseur [image create photo -format png -file [file join "Img" "viseur.png"]]

global tremblementMax
set tremblementMax 2

# Chaque objet a :
# - une position ($i,posX) et ($i,posY)
# - des vitesses ($i,vitXmin), ($i,vitXmax), ($i,vitYmin) et ($i,vitYmax)
# - un tat ($i,etat) (true = actif, false = tir)
# - une image si actif ($i,imageActif)
# - une image si tir ($i,imageTire)
global objets
array set objets [list]
global nbObjets
set nbObjets 0

global VIT_X_MIN
global VIT_X_MAX
global VIT_Y_MIN
global VIT_Y_MAX
set VIT_X_MIN -3
set VIT_X_MAX 3
set VIT_Y_MIN -3
set VIT_Y_MAX 3

global DELAI_ANIM
set DELAI_ANIM 100

global BLOQUER_AUX_BORD
set BLOQUER_AUX_BORD true

global montantGagne
set montantGagne 1

global doitFinirPourGagner
set doitFinirPourGagner true

global enTrainDeViser
set enTrainDeViser false
global enTrainDeTirer
set enTrainDeTirer false


proc initObjets {} {
}

proc ajouterObjet {posX posY etat imageActif imageTire} {
  global objets
  global nbObjets
  global VIT_X_MIN
  global VIT_X_MAX
  global VIT_Y_MIN
  global VIT_Y_MAX

  incr nbObjets
  set objets($nbObjets,posX) $posX
  set objets($nbObjets,posY) $posY
  set objets($nbObjets,vitXmin) $VIT_X_MIN
  set objets($nbObjets,vitXmax) $VIT_X_MAX
  set objets($nbObjets,vitYmin) $VIT_Y_MIN
  set objets($nbObjets,vitYmax) $VIT_Y_MAX
  set objets($nbObjets,etat) $etat
  set objets($nbObjets,imageActif) $imageActif
  set objets($nbObjets,imageTire) $imageTire
}


proc lblEsperanceMathematique {} {
  msgBox "Ce jeu tant bas sur l'adresse et non sur le hasard, le calcul de l'esprance mathmatique n'est pas applicable ici." "Esprance mathmatique"
}

proc lblAideJeu {} {
  global doitFinirPourGagner
  global montantGagne
  global PARAM

  msgBox "But du jeu : acheter des plombs et tenter de tirer sur les cibles pour gagner $montantGagne $PARAM(unite).
Pour viser, utilisez la souris (bouton gauche et dplacement dans la 'zone de vise') ou les flches directionnelles.
Pour tirer, appuyez sur la touche 'Entre' ou sur le bouton prvu  cet effet." "Aide"
}

proc affichageSpecifique {} {
}

proc initAfficheJeu {} {
  global couleurs
  global polices
  global titreJeu
  global montantGagne
  global PARAM
  global listePlombsAchetablesNbEtPrix
  global nbPlombsRestants
  global TAILLE
  global objets
  global nbObjets
  global imgViseur
  global lblExplique
#  global enTrainDeViser
global enTrainDeTirer

  destroy .frmJeu
  frame .frmJeu -background $couleurs(FondFenetreJeu)
  ajouterLigneVideHaut frmJeu $couleurs(FondFenetreJeu)
  ajouterLigneVideBas frmJeu $couleurs(FondFenetreJeu)

  ajouterLabel frmJeu lblTitre "$titreJeu" $polices(TitreJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceTitreJeu) "top"
  ajouterFrame frmJeu frmVideApresTitre $couleurs(FondFenetreJeu)

  # Zone de tir et achat de plombs
  ajouterFrame frmJeu frmZone1 $couleurs(FondFenetreJeu)

  set nbBoutonsPlombs [expr {[llength $listePlombsAchetablesNbEtPrix] / 2}]
  

#  frame .frmJeu.frmZone1.frmZoneTir -background $couleurs(FondZoneTir) -height $TAILLE -width $TAILLE
  canvas .frmJeu.frmZone1.frmZoneTir -background $couleurs(FondZoneTir) -height $TAILLE -width $TAILLE
  grid .frmJeu.frmZone1.frmZoneTir -row 1 -column 1 -rowspan [expr $nbBoutonsPlombs] ;# -sticky nsew
  
  for {set i 1} {$i <= $nbObjets} {incr i} {
    label .frmJeu.frmZone1.frmZoneTir.lblObjet$i -text "" -background $couleurs(FondZoneTir)
    if {$objets($i,etat)} {
  #    .frmJeu.frmZone1.frmZoneTir.lblObjet$i configure -image $objets($i,imageActif)
    .frmJeu.frmZone1.frmZoneTir create image 0 0 -image $objets($i,imageActif) -anchor nw -tag Objet$i ;#-anchor nw
    } else {
  #    .frmJeu.frmZone1.frmZoneTir.lblObjet$i configure -image $objets($i,imageTire)
    .frmJeu.frmZone1.frmZoneTir create image 0 0 -image $objets($i,imageTire) -anchor nw -tag Objet$i ;#-anchor nw
    }
    deplacerObjet $i $objets($i,posX) $objets($i,posY)
  }
#  label .frmJeu.frmZone1.frmZoneTir.lblViseur -text "" -image $imgViseur  ;#-background ""$couleurs(FondZoneTir)
  .frmJeu.frmZone1.frmZoneTir create image 0 0 -image $imgViseur -anchor nw -tag viseur ;#-anchor nw

  # On gnre maintenant les boutons permettant d'acheter des plombs :
  set i 1
  foreach {nb prix} $listePlombsAchetablesNbEtPrix {
    button .frmJeu.frmZone1.cmdAchat$nb -background $couleurs(FondFenetreJeu) -activebackground $couleurs(FondFenetreJeu) \
                                        -foreground $couleurs(PolicePlombs) -activeforeground $couleurs(PolicePlombs) \
                                        -font $polices(Plombs) -text "Acheter $nb plombs\n($prix $PARAM(unite))" \
                                        -command "acheterPlombs $nb $prix"
    grid .frmJeu.frmZone1.cmdAchat$nb -row $i -column 2 -padx 5
    incr i
  }

  # On ajoute enfin le nb de plombs restants :
#  label .frmJeu.frmZone1.lblNbRestants -background $couleurs(FondFenetreJeu) -foreground $couleurs(PolicePlombs) \
#                                       -font $polices(Plombs) -text ""
#  grid .frmJeu.frmZone1.lblNbRestants -row $i -column 2

  ajouterLabel frmJeu lblNbRestants "" $polices(Plombs) $couleurs(FondFenetreJeu) $couleurs(PolicePlombs)


  # Zone d'explication et de vise
  frame .frmJeu.frmZone2 -background $couleurs(FondFenetreJeu)
  pack .frmJeu.frmZone2

  set labelExplMises "           ZONE DE VISEE ====>\n\n$lblExplique"
  label .frmJeu.frmZone2.lblExpl -background $couleurs(FondFenetreJeu) -foreground $couleurs(PoliceScoresJeu) \
                                 -font $polices(ScoresJeu) -text "$labelExplMises"
  grid .frmJeu.frmZone2.lblExpl -row 1 -column 1 -rowspan 2 ;#-sticky s

#  label .frmJeu.frmZone2.lblExplVise -background $couleurs(FondFenetreJeu) -foreground $couleurs(PoliceScoresJeu) \
#                                 -font $polices(ScoresJeu) -text "Pour viser, cliquez ici et\nappuyez sur 'Entre' pour tirer"
#  grid .frmJeu.frmZone2.lblExplVise -row 1 -column 2

  frame .frmJeu.frmZone2.frmZoneVise -background $couleurs(FondZoneTir) -height [expr {int($TAILLE / 3)}] -width [expr {int($TAILLE / 3)}]
  grid .frmJeu.frmZone2.frmZoneVise -row 1 -column 2 ;# -sticky nsew
  bind .frmJeu.frmZone2.frmZoneVise <ButtonPress-1> {global enTrainDeViser; set enTrainDeViser true}
  bind .frmJeu.frmZone2.frmZoneVise <ButtonRelease-1> {global enTrainDeViser; set enTrainDeViser false}
  bind .frmJeu.frmZone2.frmZoneVise <Motion> {
       global enTrainDeViser
#       if {$enTrainDeViser} {
         deplacerViseur [expr {%x * 3}] [expr {%y * 3}]
#       }
  }
  bind .frmJeu.frmZone2.frmZoneVise <KeyPress> {
     global enTrainDeTirer
global enTrainDeViser
     if {[estToucheEntree "%k" "%K"]} {
       if {! $enTrainDeTirer} {
         set enTrainDeTirer true
         tirer
       }
     }
set RAPIDITE_VISEUR 10
       if {%k == 37} {
         # gauche
set enTrainDeViser true
foreach {x y} [.frmJeu.frmZone1.frmZoneTir coords viseur] break
deplacerViseur [expr {$x - $RAPIDITE_VISEUR}] $y
       }
       if {%k == 38} {
         # haut
set enTrainDeViser true
foreach {x y} [.frmJeu.frmZone1.frmZoneTir coords viseur] break
deplacerViseur $x [expr {$y - $RAPIDITE_VISEUR}]
       }
       if {%k == 39} {
         # droite
set enTrainDeViser true
foreach {x y} [.frmJeu.frmZone1.frmZoneTir coords viseur] break
deplacerViseur [expr {$x + $RAPIDITE_VISEUR}] $y
       }
       if {%k == 40} {
         # bas
set enTrainDeViser true
foreach {x y} [.frmJeu.frmZone1.frmZoneTir coords viseur] break
deplacerViseur $x [expr {$y + $RAPIDITE_VISEUR}]
       }
  }
  bind .frmJeu.frmZone2.frmZoneVise <KeyRelease> {
     global enTrainDeTirer
     global enTrainDeViser

     if {[estToucheEntree "%k" "%K"]} {
       set enTrainDeTirer false
     }
     if {%k == 37} {
       # gauche
set enTrainDeViser false
     }
     if {%k == 38} {
       # haut
set enTrainDeViser false
     }
     if {%k == 39} {
       # droite
set enTrainDeViser false
     }
     if {%k == 40} {
       # bas
set enTrainDeViser false
     }
  }
  focus -force .frmJeu.frmZone2.frmZoneVise

  button .frmJeu.frmZone2.cmdTirer -background $couleurs(FondFenetreJeu) -activebackground $couleurs(FondFenetreJeu) \
                                        -foreground $couleurs(PolicePlombs) -activeforeground $couleurs(PolicePlombs) \
                                        -font $polices(Plombs) -text "Pour TIRER,\ncliquez ici ou\nappuyez sur 'Entre'" \
                                        -command "tirer"
  grid .frmJeu.frmZone2.cmdTirer -row 1 -column 3 -padx 5 ;# -sticky nsew


  ajouterLabel frmJeu lblGains "" $polices(ScoresJeu) $couleurs(FondFenetreJeu) $couleurs(PoliceScoresJeu) bottom

affichageSpecifique

  pack .frmJeu -expand 1 -fill both

  afficherFrame frmJeu
}

# Gestion du dplacement du viseur :
proc deplacerViseur {px py} {
  global nbPlombsRestants
  global enTrainDeViser

  if {$enTrainDeViser} {
    if {$nbPlombsRestants > 0} {
#    place .frmJeu.frmZone1.frmZoneTir.lblViseur -x $px -y $py
      .frmJeu.frmZone1.frmZoneTir coords viseur [list $px $py]
      update
    } else {
      set enTrainDeViser false
      msgBox "Vous devez acheter des plombs..." "Tirer"
    }
  }
}


set bloque false
global nomJeuLance
set nomJeuLance ""
proc commencerJeu {} {
  global nbPlombsRestants
  global jeuEnCours
  global nomJeuCourant
  global nomJeuLance
  global bloque
  
  set bloque false
  #  set nbPlombsRestants 0
  set jeuEnCours true
  set nomJeuLance "$nomJeuCourant"
  
  initObjets
  initAfficheJeu
  majAfficheJeu
  majNomsEtScores .frmJeu.lblGains
  focus -force .frmJeu.frmZone2.frmZoneVise
  update idletasks
  animer
}

proc getListeObjetsSousViseur {} {
  global objets
  global nbObjets
  global imgViseur

  set objetsTires [list]
  foreach {viseurX0 viseurY0 viseurX1 viseurY1} [.frmJeu.frmZone1.frmZoneTir coords viseur] break
  set hauteurViseur [image height $imgViseur]
  set largeurViseur [image width $imgViseur]
  set viseurX [expr {$viseurX0 + ($largeurViseur / 2)}]
  set viseurY [expr {$viseurY0 + ($hauteurViseur / 2)}]

  for {set i 1} {$i <= $nbObjets} {incr i} {
    if {$objets($i,etat)} {
      foreach {X0 Y0} [.frmJeu.frmZone1.frmZoneTir coords Objet$i] break
      set hauteurObjet [image height $objets($i,imageActif)]
      set largeurObjet [image width $objets($i,imageActif)]

      if {$viseurX >= $X0 && $viseurX <= [expr {$X0 + $largeurObjet}] && $viseurY >= $Y0 && $viseurY <= [expr {$Y0 + $hauteurObjet}]} {
        # Touch !
        lappend objetsTires $i
      }
    }
  }
  return $objetsTires
}

proc tirer {} {
  global nbPlombsRestants
  global jeuEnCours
  global doitFinirPourGagner
  global montantGagne
  global objets
  global nbObjets
  global challenge

  if {$nbPlombsRestants > 0} {
    incr nbPlombsRestants -1
    majAfficheJeu
    incrementerStats "nb tirs" false 1

    set listeObjetsTires [getListeObjetsSousViseur]
    foreach indObjet $listeObjetsTires {
      incrementerStats "nb touchs" false 1
      set objets($indObjet,etat) false
      .frmJeu.frmZone1.frmZoneTir delete Objet$indObjet
      .frmJeu.frmZone1.frmZoneTir create image $objets($indObjet,posX) $objets($indObjet,posY) -image $objets($indObjet,imageTire) -tag Objet$indObjet -anchor nw
      .frmJeu.frmZone1.frmZoneTir raise viseur
      update
    }

    set gagne false
    set fini true
    for {set i 1} {$i <= $nbObjets} {incr i} {
      if {$objets($i,etat)} {set fini false}
    }
    if {$doitFinirPourGagner} {
      if {$fini} {
        set gagne true
#        pause $delaiAvantEfface
      }
    } else {
      set gagne true
    }
    if {$gagne} {
        gagner $montantGagne 1
        majNomsEtScores .frmJeu.lblGains
        incrementerStats "total gains" false $montantGagne
      if {$fini} {
        commencerJeu
      }
    }
    if {$challenge} {
      if {$nbPlombsRestants == 0} {
        set jeuEnCours false
        Challenge_JeuSuivant
      }
    }
  } else {
    msgBox "Veuillez acheter des plombs..." "Tirer"
  }

}

proc acheterPlombs {nb prix} {
  global nbPlombsRestants
  global joueurs

  if {$joueurs(1,score) >= $prix} {
      perdre $prix 1
      majNomsEtScores .frmJeu.lblGains
      incrementerStats "montant investi" false $prix
      incr nbPlombsRestants $nb
      majAfficheJeu
  } else {
      msgBox "Vous n'avez pas assez de points..." "Acheter"
  }

}

proc modifVitessesMinMax {indObjet} {
}

proc animer {} {
  global objets
  global nbObjets
  global jeuEnCours
  global frmCourante
  global DELAI_ANIM
  global tremblementMax
  global nomJeuCourant
  global nomJeuLance
  
  set continuer true
  while {$continuer && $jeuEnCours && ($nomJeuCourant == $nomJeuLance)} {
    set continuer false
    pause $DELAI_ANIM
    for {set indObjet 1} {$indObjet <= $nbObjets} {incr indObjet} {
      modifVitessesMinMax $indObjet
      set deplacementX [expr {$objets($indObjet,vitXmin) + int(($objets($indObjet,vitXmax) - $objets($indObjet,vitXmin) + 1) * rand())}]
      set deplacementY [expr {$objets($indObjet,vitYmin) + int(($objets($indObjet,vitYmax) - $objets($indObjet,vitYmin) + 1) * rand())}]
      set versX [expr {$objets($indObjet,posX) + $deplacementX}]
#msgBox "$objets($indObjet,posX) + $deplacementX = $versX"
      set versY [expr {$objets($indObjet,posY) + $deplacementY}]
      deplacerObjet $indObjet $versX $versY
      if {$objets($indObjet,etat)} {set continuer true}
    }
      update

    # tremblement
    foreach {viseurX0 viseurY0} [.frmJeu.frmZone1.frmZoneTir coords viseur] break
    set viseurX0 [expr {$viseurX0-$tremblementMax+int((1 + 2 * $tremblementMax)*rand())}]
    set viseurY0 [expr {$viseurY0-$tremblementMax+int((1 + 2 * $tremblementMax)*rand())}]
    .frmJeu.frmZone1.frmZoneTir coords viseur [list $viseurX0 $viseurY0]

    if {$frmCourante != "frmJeu"} {
    set continuer false
    set jeuEnCours false
    sauverStats
    }
  }
  if {$jeuEnCours} {
    # il n'y a plus d'objet
    # => on rinitialise
    initAfficheJeu
  }
}

proc deplacerObjet {indObjet versX versY} {
  global objets
  global TAILLE
  global VIT_X_MIN
  global VIT_X_MAX
  global VIT_Y_MIN
  global VIT_Y_MAX
  global BLOQUER_AUX_BORD

  set sauv [list $versX $versY]
  
  set toucheBords false
  if {$BLOQUER_AUX_BORD} {
    if {$versX < 0} { set versX 0;set toucheBords true }
    if {$versY < 0} { set versY 0;set toucheBords true }
    set img ""
    if {$objets($indObjet,etat)} {
      set img $objets($indObjet,imageActif)
    } else {
      set img $objets($indObjet,imageTire)
    }
    set largeurObjet [image width $img]
    set hauteurObjet [image height $img]
    set xMax [expr {$TAILLE - $largeurObjet}]
    set yMax [expr {$TAILLE - $hauteurObjet}]
    if {$versX >= $xMax} {set versX $xMax;set toucheBords true}
    if {$versY >= $yMax} {set versY $yMax;set toucheBords true}
  }
  #  place .frmJeu.frmZone1.frmZoneTir.lblObjet$indObjet -x $versX -y $versY
  .frmJeu.frmZone1.frmZoneTir coords Objet$indObjet [list "$versX.0" $versY]
  
  set objets($indObjet,posX) $versX
  set objets($indObjet,posY) $versY

  if {$toucheBords} {
    set objets($indObjet,vitXmin) $VIT_X_MIN
    set objets($indObjet,vitXmax) $VIT_X_MAX
    set objets($indObjet,vitYmin) $VIT_Y_MIN
    set objets($indObjet,vitYmax) $VIT_Y_MAX
  }
}


proc majAfficheJeu {} {
  global nbPlombsRestants

  .frmJeu.lblNbRestants configure -text "Nb plombs restants : $nbPlombsRestants"
}
