########################################
# Librairie de gestion d'outils hasard #
########################################

global nbOutilsHasard
set nbOutilsHasard 0 ;# Au dpart, on n'a aucun outil

# Remise  zro des outils : on n'a alors plus d'outils
proc initOutilsHasard {} {
  global listeOutilsHasard
  global nbOutilsHasard

  set nbOutilsHasard 0
}

# Ajouter un outil en spcifiant son nom et la liste de ses faces
proc ajouterOutilHasard {nom listeFaces} {
  global listeOutilsHasard
  global nbOutilsHasard

  incr nbOutilsHasard
  set listeOutilsHasard($nbOutilsHasard,nom) $nom
  set listeOutilsHasard($nbOutilsHasard,faces) $listeFaces
  set listeOutilsHasard($nbOutilsHasard,facesRestes) $listeFaces ;# Pour l'instant, toutes les faces restent
}

# Gnrer la liste des faces d'un outil,  partir d'une chaine de caractre respectant les rgles suivantes :
# - les faces sont spares par ; ou \n
# - pour chacune, on peut indiquer le nombre de faces concernes (ex : "3x")
# - on peut spcifier un intervale de valeurs numriques (ex : "1~49" pour les boules du loto)
proc genererListeFacesOutilHasard {outilFacesChaine} {
  # analyse syntaxique de outilFacesChaine :
  set faces [split $outilFacesChaine ";\n"]
  set listeFaces [list]
  foreach face $faces {
    set nb 1
    set valeurFace [string range "$face" 0 [string length "$face"]]
    set indX [string first "x" "$face"]
    if {$indX > 0} {
      set nb ""
      catch {set nb [expr 0 + [string range "$face" 0 [expr {$indX-1}]]]}
      if {$nb != ""} {
        set valeurFace [string range "$face" [expr {$indX+1}] [string length "$face"]]
      } else {
        set nb 1
        set valeurFace "$face"
      }
    }
    # gestion des ~ :
    set indSep [string first "~" "$valeurFace"]
    if {$indSep > 0} {
      set nbDeb [string range "$valeurFace" 0 [expr {$indSep-1}]]
      set nbFin [string range "$valeurFace" [expr {$indSep+1}] [string length "$valeurFace"]]
      for {set valeur $nbDeb} {$valeur <= $nbFin} {incr valeur} {
        for {set i 1} {$i <= $nb} {incr i} {
          lappend listeFaces $valeur
        }
      }
    } else {
      for {set i 1} {$i <= $nb} {incr i} {
        lappend listeFaces $valeurFace
      }
    }
  }
  return $listeFaces
}

# On tire une face d'un outil, en la remettant  la fin du tirage
proc tirerOutilAvecRemise {{indOutil 1}} {
  global listeOutilsHasard

  set nbTot [llength $listeOutilsHasard($indOutil,facesRestes)]
  if {$nbTot > 0} {
    set faceTiree [expr int(rand()*$nbTot)]
    return [lindex $listeOutilsHasard($indOutil,facesRestes) $faceTiree]
  } else {
    return ""
  }
}

# On tire une face d'un outil, sans la remettre  la fin du tirage
proc tirerOutilSansRemise {{indOutil 1}} {
  global listeOutilsHasard

  set nbTot [llength $listeOutilsHasard($indOutil,facesRestes)]
  if {$nbTot > 0} {
    set faceTiree [expr int(rand()*$nbTot)]
    set valeurTiree [lindex $listeOutilsHasard($indOutil,facesRestes) $faceTiree]
    set listeOutilsHasard($indOutil,facesRestes) [lreplace $listeOutilsHasard($indOutil,facesRestes) $faceTiree $faceTiree]
    return $valeurTiree
  } else {
    return ""
  }
}

# On remet toutes les faces de l'outil
proc remiseTotaleOutilHasard {{indOutil 1}} {
  global listeOutilsHasard

  set listeOutilsHasard($indOutil,facesRestes) $listeOutilsHasard($indOutil,faces) 
}

# Fonction permettant de tirer un nombre au hasard entre min et max inclus :
proc nbHasard {min max} {
  if {$min <= $max} {
    return [expr int((1 + $max - $min) * rand()) + $min]
  } else {
    logError "Lib_hasard.nbHasard : min > max ($min > $max)"
    return $min
  }
}