#######################################
# Librairie de gestion des highscores #
#######################################

global highScores ;# Dclaration du tableau global
global NB_HIGH_SCORES_MAX
set NB_HIGH_SCORES_MAX 10
global formatDateHighScores
set formatDateHighScores "%d/%m/%Y"

global ficScoresCourant
set ficScoresCourant [cheminComplet "highscores.txt"]

global txt
set txt(TXT_PAS_SCORES) "Aucun score pour le moment..."
set txt(TXT_FERMER_SCORES) "Fermer"
set txt(TXT_VIDER_SCORES) "Effacer les scores"
set txt(TXT_DDE_VIDER_SCORES) "tes-vous sr de vouloir vider les scores ?"
set txt(TITRE_DEFAUT_SCORES) "Meilleurs scores"
set txt(TITRE_VIDER_SCORES) "Effacer"

global scoresTailleMaxNom
set scoresTailleMaxNom 10

global couleurs
set couleurs(ScoresFondFenetre) "#ffffff"
set couleurs(ScoresFondLibelle) $couleurs(ScoresFondFenetre)
set couleurs(ScoresFondBouttons) $couleurs(ScoresFondFenetre)
set couleurs(ScoresPoliceTitre) "#000000"
set couleurs(ScoresPoliceLibelle) ""
set couleurs(ScoresPoliceBouttons) ""

# On excute le fichier des paramtres, selon la machine,
# pour mettre  jour les polices et couleurs des highscores :
global PARAM
global polices
source "initParamsInterface_$PARAM(machine)\.ini"

set polices(ScoresLib) [font create -family Courier -size $PARAM(taillePoliceBase)]
set polices(ScoresLibNouv) [font create -family Courier -size $PARAM(taillePoliceBase) -weight bold]
set polices(ScoresBouttons) ""
set polices(ScoresTitre) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 3}] -weight bold -underline true]
set polices(ScoresLibDate) [font create -family Courier -size $PARAM(taillePoliceBase) -slant italic]


# Affichage de la bote de dialogue des meilleurs scores
proc afficherHighScores {{titre ""} {frmMaster "."}} {
  global highScores
  global polices
  global couleurs
  global scoresTailleMaxNom
  global rangNouveau
  global txt

  if {$titre == ""} {
    set titre $txt(TITRE_DEFAUT_SCORES)
  }
  initDialogBox $titre $couleurs(ScoresFondFenetre)

  if {$couleurs(ScoresFondLibelle) == ""} {
    set couleurs(ScoresFondLibelle) $couleurs(ScoresFondFenetre)
  }
  if {$couleurs(ScoresPoliceLibelle) == ""} {
    set couleurs(ScoresPoliceLibelle) "#000000"
  }

  frame .frmDialog.frmAffiche -background $couleurs(ScoresFondFenetre)
catch {grid anchor .frmDialog.frmAffiche center}
  set nbCols 5
  set ligne 1
  set colonne 0

  label .frmDialog.frmAffiche.lblVideAvantTitre -text "" -background $couleurs(ScoresFondFenetre) \
       -font $polices(ScoresLib)
  grid .frmDialog.frmAffiche.lblVideAvantTitre -row [incr ligne] -column 1

  label .frmDialog.frmAffiche.lblTitre -text "$titre" -background $couleurs(ScoresFondLibelle) \
       -font $polices(ScoresTitre) -foreground $couleurs(ScoresPoliceTitre)
  grid .frmDialog.frmAffiche.lblTitre -row [incr ligne] -column 1 -padx 5 -columnspan $nbCols

  label .frmDialog.frmAffiche.lblVideApresTitre -text "" -background $couleurs(ScoresFondFenetre) \
       -font $polices(ScoresLib) -foreground $couleurs(ScoresPoliceLibelle)
  grid .frmDialog.frmAffiche.lblVideApresTitre -row [incr ligne] -column 1

#  set txtHighScores ""
  set nbHighScores [tailleHighScores]
  if {$nbHighScores > 0} {
    for {set i 1} {$i <= $nbHighScores} {incr i} {
      set colonne 0
      set date $highScores($i,date)
      set nom $highScores($i,nom)
      set score $highScores($i,score)
      set lib $highScores($i,libelle)

set police $polices(ScoresLib)
if {$i == $rangNouveau} {
  set police $polices(ScoresLibNouv)
  set rangNouveau -1 ;# on oublie (cad affich en gras une seule fois !)
}
      label .frmDialog.frmAffiche.lblScore_$ligne\_$colonne -text " $i\." -background $couleurs(ScoresFondLibelle) \
         -font $police -foreground $couleurs(ScoresPoliceLibelle)
      grid .frmDialog.frmAffiche.lblScore_$ligne\_$colonne -row [incr ligne] -column [incr colonne] -sticky e
      label .frmDialog.frmAffiche.lblScore_$ligne\_$colonne -text "($date)" -background $couleurs(ScoresFondLibelle) \
         -font $police -foreground $couleurs(ScoresPoliceLibelle)
      grid .frmDialog.frmAffiche.lblScore_$ligne\_$colonne -row $ligne -column [incr colonne]
      label .frmDialog.frmAffiche.lblScore_$ligne\_$colonne -text "$score" -background $couleurs(ScoresFondLibelle) \
         -font $police -foreground $couleurs(ScoresPoliceLibelle)
      grid .frmDialog.frmAffiche.lblScore_$ligne\_$colonne -row $ligne -column [incr colonne] -sticky e

      set nomAffiche $nom
      if {[string length $nomAffiche] > $scoresTailleMaxNom} {
        set nomAffiche [string range $nomAffiche 0 [expr {$scoresTailleMaxNom - 3}]]
        append nomAffiche "..."
      }
      label .frmDialog.frmAffiche.lblScore_$ligne\_$colonne -text "$nomAffiche" -background $couleurs(ScoresFondLibelle) \
         -font $police -foreground $couleurs(ScoresPoliceLibelle)
      grid .frmDialog.frmAffiche.lblScore_$ligne\_$colonne -row $ligne -column [incr colonne]
      
      label .frmDialog.frmAffiche.lblScore_$ligne\_$colonne -text " " -background $couleurs(ScoresFondLibelle) \
            -font $police -foreground $couleurs(ScoresPoliceLibelle)
      if {$lib != ""} {
        .frmDialog.frmAffiche.lblScore_$ligne\_$colonne configure -text "($lib) "
      }
      grid .frmDialog.frmAffiche.lblScore_$ligne\_$colonne -row $ligne -column [incr colonne] -sticky w
    }
  } else {
    label .frmDialog.frmAffiche.lblAucunScore -text " $txt(TXT_PAS_SCORES) " -background $couleurs(ScoresFondLibelle) \
       -font $polices(ScoresLib) -foreground $couleurs(ScoresPoliceLibelle)
    grid .frmDialog.frmAffiche.lblAucunScore -row [incr ligne] -column 1
  }
  label .frmDialog.frmAffiche.lblVideApresScore -text "" -background $couleurs(ScoresFondFenetre) \
     -font $polices(ScoresLib) -foreground $couleurs(ScoresPoliceLibelle)
  grid .frmDialog.frmAffiche.lblVideApresScore -row [incr ligne] -column 1

  set repAffichage [dialogBox ".frmDialog.frmAffiche" [list "$txt(TXT_FERMER_SCORES)" "$txt(TXT_VIDER_SCORES)"] \
                              $polices(ScoresLib) $polices(ScoresBouttons) \
                              $couleurs(ScoresPoliceLibelle) $couleurs(ScoresPoliceBouttons) \
                              $couleurs(ScoresFondFenetre) $couleurs(ScoresFondLibelle) $couleurs(ScoresFondBouttons) \
                              $titre "" 100]
  if {$repAffichage == 1 && $nbHighScores > 0} {
    # Clic sur "effacer" => on efface !
    viderHighScores
  }
}

# Mthode permettant d'effacer les scores, aprs confirmation
proc viderHighScores {{ddeConfirm true}} {
  global highScores
  global ficScoresCourant
  global txt

  set ok "yes"
  if {$ddeConfirm} {
    set ok [msgBox "$txt(TXT_DDE_VIDER_SCORES)" "$txt(TITRE_VIDER_SCORES)" "yesno"]
  }
  if {$ok == "yes"} {
    # On fait une sauvegarde, au cas o...
    set sauvNomFic $ficScoresCourant
    sauverHighScores "$ficScoresCourant\_sauv.txt"
    unset highScores
    sauverHighScores $sauvNomFic
  }
}

# Chargement des scores contenus dans le fichier spcifi
proc chargerHighScores {{fichier ""}} {
  global highScores
  global ficScoresCourant

  if {$fichier != ""} {
    set ficScoresCourant $fichier
  }
  catch {unset highScores}
  if {[array size highScores] <= 0} {
    set contenu [list]
    catch {set contenu [lireFichierDansListe $ficScoresCourant]}
    if {[llength $contenu] > 0 && [lindex $contenu 0] != ""} {
      set indLigne 0
      foreach ligne $contenu {
        incr indLigne
        set infos [split $ligne "|"]
        set highScores($indLigne,date) [lindex $infos 0]
        set highScores($indLigne,nom) [lindex $infos 1]
        set highScores($indLigne,score) [lindex $infos 2]
        set highScores($indLigne,libelle) [lindex $infos 3]
      }
    }
  }
}

# Sauvegarde des scores dans le fichier spcifi
proc sauverHighScores {{fichier ""}} {
  global highScores
  global ficScoresCourant

  if {$fichier != ""} {
    set ficScoresCourant $fichier
  }
  set nbHighScores [tailleHighScores]
  set contenu ""
  for {set i 1} {$i <= $nbHighScores} {incr i} {
    set date $highScores($i,date)
    set nom $highScores($i,nom)
    set score $highScores($i,score)
    set lib $highScores($i,libelle)
    if {$contenu != ""} {
      set contenu "$contenu\n"
    }
    set contenu "$contenu$date|$nom|$score|$lib"
  }
  ecrireFichier $ficScoresCourant $contenu 1
}

# Calcul de la taille du tableau des scores
proc tailleHighScores {} {
  global highScores
  global NB_HIGH_SCORES_MAX

  set tailleReelle [expr {int([array size highScores] / 4)}]
  if {$tailleReelle > $NB_HIGH_SCORES_MAX} {
    set tailleReelle $NB_HIGH_SCORES_MAX
  }
  return $tailleReelle
}

# Est-ce que le score spcifi rentre dans les highscores ?
# Si oui, retourne son rang, -1 sinon
global rangNouveau
set rangNouveau -1
proc nouveauHighScore? {nom score libelle} {
  global NB_HIGH_SCORES_MAX
  global highScores
global rangNouveau

  chargerHighScores ;# On charge les scores
  set nbHighScores [tailleHighScores]
  set rangNouveau 0
  set continuer true
  set meilleurScore false
  # On parcourt les scores, 
  # jusqu' en trouver un < au notre,
  # ou rencontrer la fin
  while {$continuer} {
    incr rangNouveau
    if {$rangNouveau > $nbHighScores} {
      if {$rangNouveau <= $NB_HIGH_SCORES_MAX} {
        set meilleurScore true
      } else {
        set continuer false
      }
    } else {
      set scoreLu $highScores($rangNouveau,score)
      if {$score > $scoreLu} {
        # On est dedans !
        set meilleurScore true
      }
    }
    if {$meilleurScore} {
      insererHighScore $nom $score $libelle $rangNouveau
      set continuer false
    }
  }
  if {! $meilleurScore} {
    set rangNouveau -1
  }
  return $rangNouveau
}

# Insertion d'un score dans le tableau des scores, au rang indiqu
proc insererHighScore {nom score libelle rang} {
  global highScores
  global formatDateHighScores

  set nbHighScores [tailleHighScores]
  # On dcale tous les autres :
  for {set i $nbHighScores} {$i >= $rang} {incr i -1} {
    set highScores([expr {$i + 1}],date) $highScores($i,date)
    set highScores([expr {$i + 1}],nom) $highScores($i,nom)
    set highScores([expr {$i + 1}],score) $highScores($i,score)
    set highScores([expr {$i + 1}],libelle) $highScores($i,libelle)
  }
  # puis on enregistre le nouveau :
  set dateJour [getClock $formatDateHighScores]
  set highScores($rang,date) $dateJour
  set highScores($rang,nom) $nom
  set highScores($rang,score) $score
  set highScores($rang,libelle) $libelle
  sauverHighScores ;# Et on sauve !
}

chargerHighScores ;# Ds le chargement, on charge les scores