###################################
# Librairie de gestion des images #
###################################

global facteurZoom
set facteurZoom 1
global PARAM

if {$PARAM(machine) == "PPC"} {
# 640X480 ou 320X240
if {[winfo screenwidth .] < 400} {
  set facteurZoom -2
}
}
catch {chargerGlobales [cheminComplet "tailleImagesBase_$PARAM(machine)\.ini"]}


proc agrandirImages {} {
  global facteurZoom
  global tabImagesFic
  global PARAM
  
  if {$facteurZoom == -1} {
    set facteurZoom 1
  }
  incr facteurZoom
  foreach fic [array names tabImagesFic] {
    if {$fic != "nomFic"} {
      set image $tabImagesFic($fic)
#      msgBox "$image $fic"
      unset tabImagesFic($fic)
      getImageFichier $fic $image
#      msgBox "$tabImagesFic($fic)"
    }
  }
#  set tabImagesFic(nomFic) image
  sauverGlobales [cheminComplet "tailleImagesBase_$PARAM(machine)\.ini"] [list "facteurZoom"] 

}



proc diminuerImages {} {
  global facteurZoom
  global tabImagesFic
  global PARAM
  
  if {$facteurZoom == 1} {
    set facteurZoom -1
  }
  incr facteurZoom -1
  foreach fic [array names tabImagesFic] {
    if {$fic != "nomFic"} {
      set image $tabImagesFic($fic)
#      msgBox "$image $fic"
      unset tabImagesFic($fic)
      getImageFichier $fic $image
#      msgBox "$tabImagesFic($fic)"
    }
  }
#  set tabImagesFic(nomFic) image
  sauverGlobales [cheminComplet "tailleImagesBase_$PARAM(machine)\.ini"] [list "facteurZoom"] 

}


global tabImagesFic
set tabImagesFic(nomFic) image

# Rcupration d'une image  partir du fichier spcifi.
# Selon facteurZoom, elle sera peut-tre diminue/agrandie
# Pas recalcule si elle existe dj dans tabImagesFic
proc getImageFichier {nomFic {nomImage ""}} {
  global tabImagesFic

  if {! [info exists tabImagesFic($nomFic)]} {
    if {$nomImage == ""} {
      set imgNorm [image create photo -format png -file "$nomFic"]
    } else {
#    msgBox "nomImage = $nomImage"
      set imgNorm [image create photo $nomImage -format png -file "$nomFic"]
    }
    set tabImagesFic($nomFic) [zoomerImage $imgNorm]
  }
  return $tabImagesFic($nomFic)
}

proc zoomerImage {imgNorm} {
  global facteurZoom
  global errorInfo

    set imgTmp $imgNorm
    set msgErr ""
    set errorInfo ""
    if {$facteurZoom > 1} {
        # zoom :
        set imgTmp [image create photo]
        catch {$imgTmp copy $imgNorm -zoom $facteurZoom $facteurZoom}
        set msgErr "$errorInfo"
        if {$msgErr == ""} {
#          image delete $imgNorm
        set imgNorm [image create photo $imgNorm]
      $imgNorm copy $imgTmp
      image delete $imgTmp
        }
    }
    if {$facteurZoom < -1} {
        # miniature :
        set imgTmp [image create photo]
        catch {$imgTmp copy $imgNorm -subsample [expr {0 - $facteurZoom}] [expr {0 - $facteurZoom}]}
        set msgErr "$errorInfo"
        if {$msgErr == ""} {
#          image delete $imgNorm
set imgNorm [image create photo $imgNorm]
      $imgNorm copy $imgTmp
      image delete $imgTmp
        }
    }
#    if {$msgErr != ""} {
      return $imgNorm
#    } else {
#      # russi
#      return $imgNorm
#    }
}

# Methode permettant de creer une image de fond degrade, avec un texte ecrit selon l'angle donne en degres (par defaut du coin inferieur gauche vers le coin superieur droit).
# l'image retournee est de type tk image
# typeDegrade peut valoir : n s e ou w ou toute combinaison de 2 points cardinaux pour les coins (ne nw se sw)
proc getImageDegrade {couleur1 couleur2 typeDegrade tailleX tailleY {texte ""} {taillePoliceTexte 10} {couleurTexte ""} {angleEnDegres ""}} {
  global errorInfo
  
  set errorInfo ""
  catch {package require pixane}
  if {$errorInfo == ""} {
    set pix [pixane create]
    pixane resize $pix $tailleX $tailleY
    pixane color $pix $couleur1
    pixane bgcolor $pix $couleur2
    set debX 0
    set debY 0
    set finX 0
    set finY 0
    if {"$typeDegrade" == ""} {
      set typeDegrade n ;# du haut vers le bas par dfaut
    }
    if {"$typeDegrade" == "n"} {
      set finY $tailleY
    }
    if {"$typeDegrade" == "s"} {
      set debY $tailleY
    }
    if {"$typeDegrade" == "e"} {
      set debX $tailleX
    }
    if {"$typeDegrade" == "w" || "$typeDegrade" == "o"} {
      set finX $tailleX
    }
  
    if {"$typeDegrade" == "ne"} {
      set finY $tailleY
      set debX $tailleX
    }
    if {"$typeDegrade" == "nw" || "$typeDegrade" == "no"} {
      set finY $tailleY
      set finX $tailleX
    }
    if {"$typeDegrade" == "se"} {
      set debY $tailleY
      set debX $tailleX
    }
    if {"$typeDegrade" == "sw" || "$typeDegrade" == "so"} {
      set debY $tailleY
      set finX $tailleX
    }
    pixane gradient $pix $debX $debY $finX $finY ;# 0 0 $tailleY $tailleY ;# 0 0 0 $tailleY = de haut en bas
    
    if {"$texte" != ""} {
      set taillePolice $taillePoliceTexte
      set font [pixfont create -builtin courier]
      lassign [pixfont measure $font $taillePolice $texte] longueur asc desc
    
      if {"$couleurTexte" == ""} {
        set couleurTexte $couleur1
      }
      pixane color $pix $couleurTexte
      if {"$angleEnDegres" == ""} {
        set angle [expr {atan($tailleY / $tailleX)}] ;# on dduit l'angle (directement en radiant)  partir des cts et en utilisant arctan pour que le texte soit align avec les coins
        set anglePourRotation [expr {3.14 * 360 / 180}] ;# angle en radian (=degres*pi/180)
        set angle [expr {$anglePourRotation - $angle}]
      } else {
        set angle [expr {3.14 * $angleEnDegres / 180}] ;# angle en radian (=degres*pi/180)
      }
      pixane text $pix [expr {$tailleX / 2}] [expr {$tailleY / 2}] -text "$texte" \
            -font $font -size $taillePolice \
            -angle $angle -align center -valign middle
            
    }
    set img [pixcopy $pix]
    pixane delete $pix
    return $img
  } else {
    # ERREUR : pixane n'est pas dispo :
    return ""
  }
}

# Mthode permettant de rajouter un cadre de couleur et d'paisseur indiques autour d'une image tk
# Retourne le nom de la nouvelle image tk ainsi "fabrique"
proc ajouterContourImage {nomImage couleur epaisseur} {
  global errorInfo
  
  set errorInfo ""
  catch {package require pixane}
  if {$errorInfo == ""} {
    set pix [pixcopy $nomImage]
    pixane color $pix $couleur
    set h [pixane height $pix]
    set w [pixane width $pix]
    # En haut
    for {set i 0} {$i < $epaisseur} {incr i} {
      pixane line $pix 0 $i $w $i
    }
    # En bas
    set deb [expr {$h - $epaisseur}]
    for {set i $deb} {$i < $h} {incr i} {
      pixane line $pix 0 $i $w $i
    }
    # A gauche
    for {set i 0} {$i < $epaisseur} {incr i} {
      pixane line $pix $i 0 $i $h
    }
    # A droite
    set deb [expr {$w - $epaisseur}]
    for {set i $deb} {$i < $w} {incr i} {
      pixane line $pix $i 0 $i $h
    }
    set img [pixcopy $pix]
    pixane delete $pix
    return $img 
  } else {
    # ERREUR : pixane n'est pas dispo :
    return ""
  }
}



# Cration d'une image de hauteur x largeur caractres,
# constitue uniquement du caractre car spcifi
# Exemple : 
# > creerImage 2 4 "d"
# dddd
# dddd
# dddd
proc creerImage {hauteur largeur {car " "}} {
  set ligne ""
  for {set i 1} {$i <= $largeur} {incr i} {
    set ligne "$ligne$car"
  }
  set imageCreee "$ligne"
  for {set i 1} {$i <= $hauteur} {incr i} {
    set imageCreee "$imageCreee\n$ligne"
  }
  return $imageCreee
}

# Gnration des pixels  partir des donnes (caractres)
# et du tableau des couleurs correspondantes
proc genererPixels {donnees tabCouleurs} {
  upvar $tabCouleurs couleurs

  # on dfinit la chane "cl valeur cl valeur..." permettant d'effectuer les substitutions :
  set mapCouleurs [array get couleurs]
  # Sans oublier l'espace :
  set mapCouleurs "$mapCouleurs \" \" \"#000 \""
  set pixelsDonnees [string map "$mapCouleurs" "$donnees"] ;# on effectue les substitutions
  set pixels [list]
  foreach ligne [split $pixelsDonnees "\n"] {
    # On supprime les ' ' gnrs  la fin de chaque ligne :
    # et on ajoute  la liste finale :
    lappend pixels [string trimright $ligne]
  }
  return $pixels
}

# Gnration complte d'une image  partir des donnes (caractres)
# et du tableau des couleurs correspondantes, 
# en sauvant ventuellement le rsultat dans le fichier spcifi
proc genererImage {donnees tabCouleurs {ficSauvPixels ""}} {
  upvar $tabCouleurs couleurs

  set pixels "[genererPixels $donnees couleurs]"
  if {$ficSauvPixels != ""} {
    ecrireFichier $ficSauvPixels $pixels 1
  }
  return [genererImagePixels $pixels]
}

# Gnration d'une image  partir d'une liste de listes 
# contenant chacune les couleurs de chaque pixel d'une ligne de l'image
proc genererImagePixels {pixels} {
  set img [image create photo]
#  logDebug "avant image put pixels"
  $img put $pixels
#  logDebug "aprs image put pixels"
  set indLigne 0
#  logDebug "avant mise en transparence"
  foreach ligne $pixels {
    set cpLigne $ligne
    set indPixel [lsearch $cpLigne "#000"]
    while {$indPixel != -1} {
      $img transparency set $indPixel $indLigne 1
      # on recopie la ligne en modifiant ce #000 en #transp, afin de trouver le suivant :
      set cpLigne [lreplace $cpLigne $indPixel $indPixel "#transp"]
      set indPixel [lsearch $cpLigne "#000"]
    }
    incr indLigne
  }
#  logDebug "aprs mise en transparence"
#  logDebug "fin de genererImage"
  return $img
}

# Largeur d'une image
proc largeurImagePixels {donnees} {
  return [string first "\n" $donnees]
}

# Superposition (calque) des donnes (caractres) d'une image A 
# sur une image B
proc superposerAsurB {imageA imageB {aPartirDeLigne 0}} {
  set imageRes "$imageB"
  set largeur [largeurImagePixels "$imageRes"]

  incr largeur
  # On parcourt les pixels de A :
  set indPixel 0
  set indLigneDest $aPartirDeLigne ;# on commence  la ligne souhaite
  set indPixelDestLigne 0 ;# on commence au premier pixel de la ligne
  while {$indPixel < [string length $imageA]} {
      set carLu [string index $imageA $indPixel]
      if {$carLu ne " "} {
        if {$carLu ne "\n"} {
          # Ce pixel n'est pas transparent => on le copie sur l'imageRes :
          set pixelDest [expr $indLigneDest * $largeur + $indPixelDestLigne]
          set imageRes [string replace $imageRes $pixelDest $pixelDest $carLu]
        } else {
          # on vient de recontrer un retour chariot 
          # donc on revient  la ligne :
          incr indLigneDest
          set indPixelDestLigne -1
        }
      }
      incr indPixel
      incr indPixelDestLigne
  }      
  return "$imageRes"
}
