######################################
# Librairie de gestion des interface #
######################################

package require Tk

# Sauvegardes des donnes de l'cran :
global PARAM
set PARAM(resolEcran) [winfo screenwidth .]
set PARAM(machine) "PPC"
if {$PARAM(resolEcran) >= 800} {
  # On est sur un poste de bureau
  set PARAM(machine) "Bureau"
}

global txt
set txt(MSG_ERR_POLICE_MIN) "Minimum atteint..."
set txt(TITRE_ERR_POLICE_MIN) "Opration impossible"

global clavierAuto
set clavierAuto false

proc afficherClavier {} {
  global clavierAuto
  global PARAM
  if {$clavierAuto && $PARAM(machine) == "PPC"} {
    catch {wce sipshow}
  }
}
proc refermerClavier {} {
  global PARAM
  if {$PARAM(machine) == "PPC"} {
    catch {wce siphide}
  }
}

set PARAM(taillePoliceBase) 10
if {$PARAM(machine) == "PPC"} {
  catch {package require wce} ;# On est sur un PPC => on tente de charger le package wce, fourni avec eTcl
  set clavierAuto true
  refermerClavier
set PARAM(taillePoliceBase) 6
}
catch {chargerGlobales [cheminComplet "taillePoliceBase_$PARAM(machine)\.ini"]}


# icone ventuelle de l'application
set PARAM(icone) [file join "Img" "icone.ico"]

### Gestion des fentres :
global frmCourante
set frmCourante ""

# Initialisation de la fentre principale
proc initFenetre {titre largeur hauteur {left 0} {top 0}} {
  global PARAM

  wm title . [replaceAll "$titre" "\n" " "]
  wm geometry . "$largeur\x$hauteur\+$left\+$top"
# Si on est en Tk 8.5, 
# on repositionne l'anchor du grid  "center"
# (fonctionnement par dfaut de Tk 8.4)
catch {grid anchor . center}
  catch "wm iconbitmap . $PARAM(icone)"
}

# Bascule d'une frame  une autre
proc afficherFrame {idFrame} {
  global frmCourante

#  if {$idFrame != $frmCourante} {
    if {$frmCourante != ""} {
      effacerFrameCourante
    }
    pack configure .$idFrame -expand 1 -fill both
    set frmCourante $idFrame
#  }
}
# Effacement de la frame courante
proc effacerFrameCourante {} { 
  global frmCourante

  if {$frmCourante != ""} {
    pack forget .$frmCourante
    set frmCourante ""
  }
}

### Pause dans le code (dlai d'attente avant l'excution de l'instruction suivante)
set PARAM(vitesse) 1
global MILLI_MAX
set MILLI_MAX 200 ;# On "dcoupe" la pause en plusieurs pauses de MILLI_MAX ms, pour mieux grer les vnements
# Faire une pause de milli millisecondes (* vitesse)
proc pause {milli} {
  global PARAM
  global MILLI_MAX

  update
  if {$PARAM(vitesse) > 0} {
    set milli [expr int($milli * $PARAM(vitesse))]
    set nb [expr int($milli / $MILLI_MAX)]
    set reste [expr $milli % $MILLI_MAX]
    for {set i 1} {$i <= $nb} {incr i} {
      after $MILLI_MAX
      update
    }
    after $reste
    update
  } ;# Sinon, 0 => instantann => pas de pause !
}
# Initialisation de la vitesse d'affichage (par dfaut, normale) :
global vitesseAffichage
proc setVitesseAffichage {{nouvValeur 2}} {
  global PARAM
  global vitesseAffichage

  set PARAM(vitesse) $nouvValeur
  if {$nouvValeur == 0} {
    # Instantan
    set PARAM(vitesse) 0
  }
  if {$nouvValeur == 1} {
    # Rapide 
    set PARAM(vitesse) 0.5
  }
  if {$nouvValeur == 2} {
    # Normale 
    set PARAM(vitesse) 1
  }
  if {$nouvValeur == 3} {
    # Lent 
    set PARAM(vitesse) 2
  }
  set vitesseAffichage $nouvValeur
}
setVitesseAffichage


# Gestion de la langue (par dfaut, FR)
global langueAffichage
set langueAffichage "FR"
proc setLangueAffichage {{nouvValeur "FR"}} {
  global langueAffichage
  set langueAffichage $nouvValeur
  majLangueAffichage
}
proc majLangueAffichage {} {
  # Fonction  dfinir dans chaque programme...
  # Par dfaut, elle affiche le message suivant :
  msgBox "Fonction non implmente..." "Langue" "ok" "warning"
}


# Mthode permettant de modifier la taille 
# d'une police en l'incrmentant de $increment
# (qui peut tre ngatif pour diminuer la taille du texte)
# Si la variable indique est un tableau (et non un de ses lment)
# alors toutes les polices du tableau seront modifies
proc incrementerPolice {variable increment} {
    set indParenth [string first "(" $variable]
    if {$indParenth > 0} {
      set variableTab [string range $variable 0 [expr {$indParenth - 1}]]
      global $variableTab
    } else {
      global $variable
    }
    if {[array exists $variable]} {
      foreach nom [array names $variable] {
#        set valeur "[subst $[subst $variable]($nom)]"
#        set contenu "$contenu$variable\($nom\)\n$valeur\n"
incrementerPolice [subst $variable\($nom\)] $increment
      }
    } else {
      set nomFont "[subst $[subst $variable]]"
#      set contenu "$contenu$variable\n$valeur\n"
if {$nomFont != ""} {
  font configure $nomFont -size [expr {[font actual $nomFont -size] + $increment}]
}
#update
    }
}

# Mthode permettant de modifier la taille 
# de TOUTES les polices du tableau global "polices"
proc incrementerPolices {{increment 1} {sauverDansFic true}} {
  global PARAM
  global txt

  if {$PARAM(taillePoliceBase) > [expr {0 - $increment}] || $increment >= 0} {
    incrementerPolice polices $increment
update idletasks
set PARAM(taillePoliceBase) [expr {$PARAM(taillePoliceBase) + $increment}]
if {$sauverDansFic} {
  sauverGlobales [cheminComplet "taillePoliceBase_$PARAM(machine)\.ini"] [list "PARAM(taillePoliceBase)"] 
}
  } else {
    msgBox "$txt(MSG_ERR_POLICE_MIN)" "$txt(TITRE_ERR_POLICE_MIN)" "ok" "error"
  }
}



proc replaceAll {chaineDepart chaineCherchee chaineRemplace} {
set res ""
  if {[string match "*$chaineCherchee*" $chaineRemplace]} {
    # chaineRemplace contient chaineCherchee => risque de boucle infinie
    # => on effectue les replaces  la main :
set tailleCherchee [string length $chaineCherchee]
    set indTrouve 0 ;# pour rentrer ds la boucle
    set chaineDepartReste $chaineDepart
    while {$indTrouve >= 0} {
      set indTrouve [string first "$chaineCherchee" "$chaineDepartReste"]
      if {$indTrouve >= 0} {
        append res "[string range $chaineDepartReste 0 [expr {$indTrouve - 1}]]$chaineRemplace"
        set chaineDepartReste [string range $chaineDepartReste [expr {$indTrouve + $tailleCherchee}] end]
      } else {
        append res $chaineDepartReste
      }
    }
  } else {
if {[string length $chaineCherchee] == 1} {
return [replaceAllSingle $chaineDepart $chaineCherchee $chaineRemplace]
} else {
  set resPrec ""
  set res $chaineDepart
set tmp ""
if {"$chaineCherchee" == "-"} {
 set chaineCherchee {\-}
}
  while {$res != $resPrec} {
    regsub $chaineCherchee $res $chaineRemplace tmp
set resPrec $res
set res $tmp
  }
  }
}
#msgBox "$chaineDepart $chaineCherchee $chaineRemplace = $res"
  return $res
}


proc replaceAllSingle {chaineDepart carCherche chaineRemplace} {
  set liste [split $chaineDepart $carCherche]
  return [liste2chaine $liste $chaineRemplace]
}



# Bote de dialogue "A propos..."
proc frmAbout {{ficCopyright "COPYRIGHT"}} {
  global PARAM
  global langueAffichage

  set txtCopyright ""
  if {$ficCopyright != ""} {
    if {[file exists $ficCopyright]} {
      set txtCopyright "[lireFichier $ficCopyright]"
    }
  }
  set nom [replaceAll "$PARAM(nomLongAppli)" "\n" " "]
  if {$langueAffichage == "FR"} {
    set message "\"$nom\" $PARAM(verAppli) ($PARAM(dateVer))\n"
    if {$txtCopyright != ""} {
      append message "$txtCopyright\nDistribu sous contrat Creative Commons.\n"
    }
    append message "\nLogiciel gratuit crit en Tcl/Tk (eTcl v1.0.0) par Newmagic (http://newmagic.progs.izfree.com)\nnewmagic.progs@gmail.com\n"
    append message "Redistribution GRATUITE et modifications autorises par l'auteur, sous rserve d'en donner crdit"
    if {$txtCopyright != ""} {
      append message " et d'inclure la licence d'origine."
    } else {
      append message "."
    }
    tk_messageBox -icon info \
            -title "A propos du programme..." \
            -message $message
  } else {
    set message "\"$nom\" $PARAM(verAppli) ($PARAM(dateVer))\n"
    if {$txtCopyright != ""} {
      append message "$txtCopyright\nDistributed under a Creative Commons license.\n"
    }
    append message "\nFreeware written in Tcl/Tk (eTcl v1.0.0) by Newmagic (http://newmagic.progs.izfree.com)  newmagic.progs@gmail.com\n"
    append message "FREE Redistribution and modifications autorized by author, if credits are given"
    if {$txtCopyright != ""} {
      append message " and the original license included."
    } else {
      append message "."
    }
    tk_messageBox -icon info \
            -title "About..." \
            -message $message
  }
}

# Bote de dialogue "Licence..."
proc frmLicence {{ficLicence "COPYING"} {ficCopyright "COPYRIGHT"}} {
  global polices
  global couleurs
  global PARAM
  global langueAffichage
  global polices

  if {! [file exists $ficLicence]} {
    # On essaye avec _langueAffichage :
    set ficTmp "$ficLicence\_$langueAffichage"
    if {[file exists $ficTmp]} {
      set ficLicence $ficTmp
    } else {
      # On essaye la version _EN :
      set ficTmp "$ficLicence\_EN"
      if {[file exists $ficTmp]} {
        set ficLicence $ficTmp
      } else {
        # On essaye en dernier recours avec _FR :
        set ficTmp "$ficLicence\_FR"
        if {[file exists $ficTmp]} {
          set ficLicence $ficTmp
        }
      }
    }
  }
  if {! [file exists $ficLicence]} {
      # Sinon, on affiche frmAbout... (mieux que rien)
      frmAbout
  } else {
    set deplacable false
    set titre "Licence"
    set libTitre "Licence de $PARAM(nomAppli)"
    if {$langueAffichage != "FR"} {
      set titre "License"
      set libTitre "License of $PARAM(nomAppli)"
    }
    set libSousTitre ""
    if {[file exists $ficCopyright]} {
      set libSousTitre "[lireFichier $ficCopyright]"
    }
    set policeTexte ""
    if {[info exists polices(Licence)]} {
      set policeTexte $polices(Licence)
    }
    afficherFrmTexte $titre $libTitre $libSousTitre [lireFichier "$ficLicence"] "" $policeTexte
  }
}

proc afficherFrmTexte {titreFenetre libTitre libSousTitre texte {policeTitre ""} {policeTexte ""} {couleurFond ""} {couleurTexte ""} {bouttonFermer ""}} {
  global polices
  global couleurs
  global PARAM

  if {$policeTitre == ""} {set policeTitre $polices(Titre)}
  if {$policeTexte == ""} {set policeTexte $polices(Normale)}
  if {$couleurFond == ""} {set couleurFond $couleurs(FondFenetre)}
  if {$couleurTexte == ""} {set couleurTexte $couleurs(Police)}

    initDialogBox $titreFenetre $couleurFond false ;# false car non dplacable (sinon on ne peut plus scroller)
    if {$PARAM(machine) == "PPC"} {
      wm geometry .frmDialog "$PARAM(largeur)\x$PARAM(hauteur)\+0+0"
    }

    frame .frmDialog.frmAffiche -background $couleurFond \
 ;#-width [expr int($PARAM(largeur) * 80 / 100)]
    ajouterLabel frmDialog.frmAffiche lblTitre "$libTitre" $policeTitre $couleurFond $couleurTexte
    if {$libSousTitre != ""} {
      ajouterLabel frmDialog.frmAffiche lblSousTitre "$libSousTitre" $policeTexte $couleurFond $couleurTexte
    }
    if {$PARAM(machine) == "PPC" && $bouttonFermer == ""} {
      set bouttonFermer "Ok"
    }
    if {$bouttonFermer != ""} {
      button .frmDialog.frmAffiche.cmdFermer -text "$bouttonFermer" -command "destroy .frmDialog" \
           -font $policeTexte -foreground $couleurTexte -background $couleurFond 
      pack .frmDialog.frmAffiche.cmdFermer -side top -padx 2 -pady 2
    }
    text .frmDialog.frmAffiche.txt -background $couleurFond -foreground $couleurTexte \
        -font $policeTexte -yscrollcommand ".frmDialog.frmAffiche.scrY set" -wrap word \
 ;#-width [expr int($PARAM(largeur) * 80 / 100)]
     scrollbar .frmDialog.frmAffiche.scrY -com {scrollYFrmTexte} ;# -width 25
    if {"$PARAM(machine)" == "PPC"} {
      .frmDialog.frmAffiche.scrY configure -width 25
    }
    .frmDialog.frmAffiche.txt insert end $texte
    .frmDialog.frmAffiche.txt configure -state disabled
    pack .frmDialog.frmAffiche.scrY -side right -fill y
    pack .frmDialog.frmAffiche.txt -side left -fill both

    set repAffichage [dialogBox ".frmDialog.frmAffiche" [list "Ok"] \
                                $policeTexte $policeTexte \
                                $couleurTexte $couleurTexte \
                                $couleurFond $couleurFond $couleurFond \
                                $titreFenetre]
}
proc scrollYFrmTexte {args} {
  eval [list .frmDialog.frmAffiche.txt yview] $args
  update idletasks
}

### Cration du menu d'une fentre :
proc creerMenuFichier {nomFichier {racine .menu} {menuContextuel false}} {
  creerMenuChaine "[lireFichier $nomFichier]" "$racine" $menuContextuel
}
# Format accept : 
# - Des espaces d'intentation pour le niveau
# - Puis le libell  afficher (un '_' peut prcder le caractre  souligner pour raccourci Alt-... MENU COMMANDE UNIQUEMENT)
#    prcd ventuellement du nom de la variable globale indiquant qu'il doit tre coch
#    de la forme : (MA_VAR[=valeur]) si valeur n'est pas spcifie, une valeur vraie coche le menu
#   ou --- pour un sparateur
# - Puis l'ventuelle commande entre <>
# - Suivie ventuellement du raccourci clavier Ctrl-... ou F..., etc. UNIQUEMENT pour les menus commandes
#   (fourni  titre d'affichage uniquement : le bind est  ajouter dans l'appli)
proc creerMenuChaine {chaine {racine .menu} {menuContextuel false}} {
  set lignes [split $chaine "\n"]
  set indentLast -1
  set idMenu 10
  set indent(1) -1

  # On cre le menu :
  destroy $racine$idMenu
if {$menuContextuel} {
  menu $racine$idMenu -tearoff 0
} else {
  menu $racine$idMenu
  . configure -menu $racine$idMenu
}

  foreach ligne $lignes {
    if {[string match "*(*)*" $ligne] && ! [string match "*<*>*" $ligne]} {
      set ligne "$ligne < >"
    }
    set ligneSansEsp [string trimleft $ligne]
    set indentation [expr [string length $ligne] - [string length $ligneSansEsp]]

    if {$indentation > $indentLast} {
      # On cre un nouveau niveau :
      set idMenu [expr {10 + $idMenu * 100}]
    } elseif {$indentation == $indentLast} {
      # On est au mme niveau :
      incr idMenu
    } else {
      # On est descendu d'un (ou plusieurs) niveau(x) :
      while {$idMenu > 100 && $indent($idMenu) > $indentation} {
        set idMenu [expr {0 + $idMenu / 100}]
      }
      incr idMenu
    }
    set indent($idMenu) $indentation

    if [string match "---*" $ligneSansEsp] {
      ajouterMenuSeparation "" [idMenuParent $idMenu $racine]
    } elseif [string match "*<*>*" $ligneSansEsp] {
      set libelle [string range $ligneSansEsp 0 [expr [string first "<" $ligneSansEsp]-1]]
      set libelle [string trim $libelle]
      set commande [string range $ligneSansEsp [expr [string first "<" $ligneSansEsp]+1] [expr [string first ">" $ligneSansEsp]-1]]
      set commande [string trim $commande]
      if [string match "(*)*" $libelle] {
        set nomVariable [string range $libelle [expr [string first "(" $libelle]+1] [expr [string first ")" $libelle]-1]]
        set nomVariable [string trim $nomVariable]
        set valeur "true"
        set indEgal [string first "=" $nomVariable]
        if {$indEgal >= 0} {
          set valeur [string range $nomVariable [expr {$indEgal + 1}] end]
          set nomVariable [string range $nomVariable 0 [expr {$indEgal - 1}]]
        }
        if {$nomVariable == ""} {
          set nomVariable "varMnu$idMenu"
        }
        global $nomVariable
        set libelle [string range $libelle [expr [string first ")" $libelle]+1] [string length $libelle]]
        set libelle [string trim $libelle]
        ajouterMenuCheck "$libelle" "$commande" "$nomVariable" "$valeur" "" [idMenuParent $idMenu $racine]
      } else {
        # C'est un menu commande : on regarde s'il dispose d'un raccourci clavier :
        set raccourci [string range $ligneSansEsp [expr {[string first ">" $ligneSansEsp] + 1}] end]
        set raccourci [string trim $raccourci]
        # et d'un _
        set indUnderscore [string first "_" $ligneSansEsp]
        if {$indUnderscore < 0} {
          set indUnderscore ""
        } else {
          set libelleTmp [string range $libelle 0 [expr {$indUnderscore - 1}]]
          append libelleTmp [string range $libelle [expr {$indUnderscore + 1}] end]
          set libelle $libelleTmp
        }
          ajouterMenuCommande "$libelle" "$commande" $indUnderscore "$raccourci" "" [idMenuParent $idMenu $racine]
      }
    } else {
        # recherche d'un _
        set indUnderscore [string first "_" $ligneSansEsp]
        if {$indUnderscore < 0} {
          set indUnderscore ""
        } else {
          set libelleTmp [string range $ligneSansEsp 0 [expr {$indUnderscore - 1}]]
          append libelleTmp [string range $ligneSansEsp [expr {$indUnderscore + 1}] end]
          set ligneSansEsp $libelleTmp
        }
      ajouterMenuCascade $racine$idMenu $ligneSansEsp $indUnderscore "" [idMenuParent $idMenu $racine]
    }
    set indentLast $indentation
  }
}
# Ajouter un menu cascade  la fentre, sous le menu parent :
proc ajouterMenuCascade {id libelle indSouligne fenetre parent} {
  menu $fenetre$parent$id -tearoff 0
  if {"$indSouligne" != ""} {
    $fenetre$parent add cascade -menu $fenetre$parent$id -label "$libelle" -underline $indSouligne
  } else {
    $fenetre$parent add cascade -menu $fenetre$parent$id -label "$libelle"
  }
}
# Ajouter un menu commande  la fentre, sous le menu parent :
proc ajouterMenuCommande {libelle cmd indSouligne raccourci fenetre parent} {
  global PARAM
  if {"$raccourci" != "" && $PARAM(machine) != "PPC"} {
    if {"$indSouligne" != ""} {
      $fenetre$parent add command -label "$libelle" -command "$cmd" -underline $indSouligne -accelerator "$raccourci"
    } else {
      $fenetre$parent add command -label "$libelle" -command "$cmd" -accelerator "$raccourci"
    }
#    set raccourci [string tolower $raccourci]
#    set map [list]
#    lappend map ctrl Control ctl Control ctr Control control Control
#    lappend map shft Shift sht Shift shf Shift maj Shift shift Shift
#    lappend map f1 F1 f2 F2 f3 F3 f4 F4 f5 F5 f6 F6
#    lappend map f7 F7 f8 F8 f9 F9 f10 F10 f11 F11 f12 F12
#    lappend map + -
#msgBox "$raccourci"
#    bind . <[string map $map $raccourci]> "$cmd"
  } else {
    if {"$indSouligne" != ""} {
      $fenetre$parent add command -label "$libelle" -command "$cmd" -underline $indSouligne
    } else {
      $fenetre$parent add command -label "$libelle" -command "$cmd"
    }
  }
}
# Ajouter un menu "cochable"  la fentre, sous le menu parent, selon la variable globale indique :
proc ajouterMenuCheck {libelle cmd nomVariable valeur fenetre parent} {
  global $nomVariable
  if {$cmd != ""} {
    $fenetre$parent add check -label "$libelle" -command "$cmd" -variable $nomVariable -onvalue $valeur
  } else {
    $fenetre$parent add check -label "$libelle" -variable $nomVariable -onvalue $valeur
  }
}
# Ajouter un menu de sparation  la fentre, sous le menu parent :
proc ajouterMenuSeparation {fenetre parent} {
  $fenetre$parent add separator
}
# Rcupration du nom du menu parent  partir d'un id de menu :
proc idMenuParent {idMenuFils racine} {
  set resultat ""
#  set restant [expr $idMenuFils]
  set restant [expr {0 + $idMenuFils}]
  while {[expr {0 + $restant / 100}] >= 10} {
    set restant [expr {0 + $restant / 100}]
    set resultat "$racine$restant$resultat"
  }
  return $resultat
}


# Menu contextuel
proc associerMenuContextuel {idWidget nomFicMenu {boutonSouris 3} {dynamique false}} {
  global PARAM
  if {$PARAM(machine) == "PPC" && $boutonSouris == 3} {
    catch {wce tapandhold $idWidget on}
  }
  bind $idWidget <ButtonPress-$boutonSouris> "afficherMenuContextuel \"$nomFicMenu\" {%X} {%Y} $dynamique"
}
# Affichage du menu contextuel
proc afficherMenuContextuel {nomFicMenu posX posY {dynamique false}} {
  global txt
  if {! $dynamique} {
    creerMenuFichier $nomFicMenu .mnuCtx true
  } else {
    creerMenuChaine [subst [lireFichier $nomFicMenu]] .mnuCtx true
  }
  .mnuCtx10 post $posX $posY
}
# supression du menu contextuel 
proc desassocierMenuContextuel {idWidget {boutonSouris 3}} {
  global PARAM
  if {$PARAM(machine) == "PPC" && $boutonSouris == 3} {
    catch {wce tapandhold $idWidget off}
  }
  bind $idWidget <ButtonPress-$boutonSouris> ""
}


###  Cration de widgets dans une frame :
# Ajout d'une frame
proc ajouterFrame {idFrameParent idFrameAjout couleurFond {emplacement ""}} {
  frame .$idFrameParent.$idFrameAjout -background "$couleurFond"
catch {grid anchor .$idFrameParent.$idFrameAjout center}
  afficherWidget $idFrameParent $idFrameAjout $emplacement true
}
# Ajout d'une ligne vide en haut (utile notamment pour le PPC)
proc ajouterLigneVideHaut {idFrame couleurFond} {
  label .$idFrame.lblLigneVideHaut -text "" \
                              -background "$couleurFond"
  afficherWidget $idFrame lblLigneVideHaut top true
}
# Ajout d'une ligne vide en bas (utile notamment pour le PPC)
proc ajouterLigneVideBas {idFrame couleurFond} {
  label .$idFrame.lblLigneVideBas -text "" \
                              -background "$couleurFond"
  afficherWidget $idFrame lblLigneVideBas bottom true
}
# Ajout d'un bouton
proc ajouterBoutton {idFrame idWidget texte commande {emplacement ""}} {
  button .$idFrame.$idWidget -text "$texte" -command "$commande"
  afficherWidget $idFrame $idWidget $emplacement false
}
# Ajout d'un label
proc ajouterLabel {idFrame idWidget texte police couleurFond couleurPolice {emplacement ""}} {
  label .$idFrame.$idWidget -text "$texte" \
                              -font "$police" \
                              -background "$couleurFond" \
                              -foreground "$couleurPolice"
  afficherWidget $idFrame $idWidget $emplacement false
}
# Ajout d'un couple label/entry selon la variable globale fournie
proc ajouterLibelleChamp {idFrame nomVariable libelle police couleurFond couleurPolice {tailleEntry ""} {emplacement ""}} {
  global $nomVariable

  ajouterFrame $idFrame frm$nomVariable $couleurFond $emplacement
  label .$idFrame.frm$nomVariable.lbl$nomVariable -text "$libelle" \
                              -font "$police" \
                              -background "$couleurFond" \
                              -foreground "$couleurPolice"

  entry .$idFrame.frm$nomVariable.txt$nomVariable -textvariable $nomVariable
  if {$tailleEntry != ""} {
  .$idFrame.frm$nomVariable.txt$nomVariable configure -width $tailleEntry
  }
  afficherWidget $idFrame.frm$nomVariable lbl$nomVariable left false
  afficherWidget $idFrame.frm$nomVariable txt$nomVariable left false
}
# Ajout d'un champs de texte sur plusieurs lignes, bas sur la variable globale fournie
proc ajouterTexte {idFrame nomVariable police emplacement hauteur largeur} {
  global $nomVariable
  text .$idFrame.txt$nomVariable -height $hauteur -width $largeur
  afficherWidget $idFrame txt$nomVariable $emplacement false
}
# Ajout d'un champs de texte sur une ligne, bas sur la variable globale fournie
proc ajouterEntry {idFrame nomVariable police emplacement} {
  global $nomVariable
  entry .$idFrame.txt$nomVariable -textvariable $nomVariable -font $police
  afficherWidget $idFrame txt$nomVariable $emplacement false
}
# Ajout d'un message (?)
proc ajouterMessage {idFrame idWidget texte police couleurFond couleurPolice {emplacement ""}} {
  message .$idFrame.$idWidget -text "$texte" \
                              -font "$police" \
                              -background "$couleurFond" \
                              -foreground "$couleurPolice"
  afficherWidget $idFrame $idWidget $emplacement true
}

proc ajouterListe {idFrame idWidget hauteur} {
# essayer : tk_optionMenu path varName value ?value value ...?
  listbox .$idFrame.$idWidget -height $hauteur

  # Ajout d'un ascenseur vertical :
  set idAscenVert $idWidget"scrVert"
  scrollbar .$idFrame.$idAscenVert -orient vertical

  # placement
#  grid .$idFrame.$idWidget -row $hauteur -column 0
#  grid .$idFrame.$idAscenVert -row $hauteur -column 1 -sticky ns

  # liens
  .$idFrame.$idWidget configure -yscrollcommand [list .$idFrame.$idAscenVert set]
  .$idFrame.$idAscenVert configure -command [list .$idFrame.$idWidget yview]

  afficherWidget $idFrame $idWidget left false
  afficherWidget $idFrame $idAscenVert left false
}

proc getIdListeChoisi {idListe} {
  return [$idListe curselection]
}

proc getLibListeChoisi {idListe} {
  return [$idListe get [getIdListeChoisi $idListe]]
}

proc ajouterListeDeroulante {idFrame idWidget liste nomVariable taille police {emplacement ""}} {
  global $nomVariable

  menubutton .$idFrame.$idWidget -menu .$idFrame.$idWidget.lst$nomVariable -textvar $nomVariable \
    -background "#ffffff" -activebackground "#ffffff" \
    -foreground "#000000" -activeforeground "#000000" \
    -relief sunken -borderwidth 1 \
    -font $police -width $taille
  menu .$idFrame.$idWidget.lst$nomVariable -tearoff 0 -font $police
  foreach value "$liste" {
    .$idFrame.$idWidget.lst$nomVariable add command -font $police -label "$value" -command [list set $nomVariable "$value"]
  }
  afficherWidget $idFrame $idWidget $emplacement false
}

proc majListeDeroulante {idFrame idWidget liste nomVariable} {
  pack forget .$idFrame.$idWidget
  ajouterListeDeroulante $idFrame $idWidget "$liste" $nomVariable"
}

proc ajouterCheckButton {idFrame idWidget libelle nomVariable police couleurFond couleurPolice {emplacement ""}} {
  global $nomVariable

  checkbutton .$idFrame.$idWidget -variable $nomVariable \
    -text $libelle \
    -background $couleurFond -activebackground $couleurFond \
    -foreground $couleurPolice -activeforeground $couleurPolice \
    -font $police -offvalue false -onvalue true
  afficherWidget $idFrame $idWidget $emplacement false
}

# Affichage du widget
proc afficherWidget {idFrame idWidget position expand} {
  pack configure .$idFrame.$idWidget
  if {$expand} {
    pack configure .$idFrame.$idWidget -expand 1 -fill x
  }
  if {$position != ""} {
    pack configure .$idFrame.$idWidget -side $position
  }
}

################################################
####        Gestion d'autres fentres       ####
################################################
### Gestion du dplacement de la fentre  la souris :
global idDraggedObject
global diffx ;# coordonnes de la souris sur l'objet
global diffy
global currx ;# coordonne courante de l'objet dans la fentre
global curry
global bloque ;# blocage si en cours de dplacement
set idDraggedObject ""
set diffx 0
set diffy 0
set currx 0
set curry 0
set bloque false 

# On lche l'objet :
proc dropDraggedObject {} {
  global idDraggedObject
  global diffx
  global diffy
  global currx
  global curry
  global bloque

  set idDraggedObject ""
  set diffx 0
  set diffy 0
  set currx 0
  set curry 0
  set bloque false
}

# Agrippement d'une fentre :
proc dragTopLevel {idTopLevel x y} {
  global idDraggedObject
  global diffx
  global diffy
  global currx
  global curry
  global bloque
 
  set bloque false
  set idDraggedObject $idTopLevel
  set diffx $x
  set diffy $y
  set nb [scan [wm geometry $idDraggedObject] %dx%d+%d+%d w h currx curry]
}
# Dplacement de la fentre :
proc moveTopLevel {px py} {
  global idDraggedObject
  global diffx
  global diffy
  global currx
  global curry
  global bloque

  if {$idDraggedObject != "" && ! $bloque} {
    set bloque true
    set currx [expr {$currx - $diffx + $px}]
    set curry [expr {$curry - $diffy + $py}]
    wm geometry $idDraggedObject "+$currx\+$curry"
    update
    set bloque false
  }
}
# Ajout de la gestion du DragAndDrop sur une fentre :
proc gestionDragDropTopLevel {topLevel} {
  bind $topLevel <ButtonPress-1> "dragTopLevel $topLevel {%x} {%y}"
  bind $topLevel <ButtonRelease-1> {dropDraggedObject}
  bind $topLevel <Motion> {moveTopLevel %x %y}
}

### Gestion du dplacement d'un widget  la souris :
# Agrippement du widget :
proc dragWidgetPlace {idWidget x y} {
  global idDraggedObject
  global diffx
  global diffy
  global currx
  global curry
  global bloque

  set bloque false
  set idDraggedObject $idWidget
  set diffx $x
  set diffy $y
  foreach {info valeur} [place info $idWidget] {
    if {$info == "-x"} {
      set currx $valeur
    }
    if {$info == "-y"} {
      set curry $valeur
    }
  }
}
# Dplacement :
proc moveWidgetPlace {px py} {
  global idDraggedObject
  global diffx
  global diffy
  global currx
  global curry
  global bloque

  if {$idDraggedObject != "" && ! $bloque} {
    set bloque true
    set currx [expr {$currx - $diffx + $px}]
    set curry [expr {$curry - $diffy + $py}]
    place $idDraggedObject -x $currx -y $curry
    update
    set bloque false
  }
}
# Ajout de la gestion du DragAndDrop sur un widget (place) :
proc gestionDragDropPlace {idWidget} {
  bind $idWidget <ButtonPress-1> "dragWidgetPlace $idWidget {%x} {%y}"
  bind $idWidget <ButtonRelease-1> {dropDraggedObject}
  bind $idWidget <Motion> {moveWidgetPlace %x %y}
}


# Centrer une fentre  l'cran
proc centrerTopLevel {topLevel {masquerBordures false}} {
  global PARAM

  #wm deiconify $topLevel
wm overrideredirect $topLevel true
  update idletasks

  catch "wm iconbitmap $topLevel $PARAM(icone)"
  set x [expr {([winfo screenwidth .] - [winfo width $topLevel]) / 2}]
  set y [expr {([winfo screenheight .] - [winfo height $topLevel]) / 2}]
  
  wm geometry $topLevel  +${x}+${y}

wm withdraw $topLevel
if {! $masquerBordures} {
  wm overrideredirect $topLevel false
}
wm deiconify $topLevel
# diffrence de comportement sous linux : la fentre est raffiche en haut  gauche...
# Donc on la replace au centre (flash sous linux et sans changement sous Windows)
wm geometry $topLevel  +${x}+${y}
}


### Fentre demandant  l'utilisateur de patienter pendant un chargement :
proc afficherFrmAttente {{msgEntete ""} {msgAttente ""} {couleurFond "#ffffff"} {couleurTexte "#000000"}} {
global langueAffichage
global txt

destroy .frmAttente

  frame .frmAttente -background $couleurFond
  #ajouterFrame "" frmAttente $couleurFond
  ajouterLigneVideHaut frmAttente $couleurFond
  ajouterLigneVideBas frmAttente $couleurFond
  if {$msgEntete == ""} {
    if {$langueAffichage == "FR"} {
      set msgEntete "Chargement en cours...\nVeuillez patienter..."
    } else {
      set msgEntete "Data processing...\nPlease wait..."
    }
    catch {set msgEntete $txt(MSG_ATTENTE)}
  }
  label .frmAttente.lblAttente -background $couleurFond -text $msgEntete -foreground $couleurTexte
  pack .frmAttente.lblAttente -expand 1 -fill x

  label .frmAttente.lblMessage -background $couleurFond -text $msgAttente -foreground $couleurTexte
  pack .frmAttente.lblMessage -side bottom -expand 1 -fill x
  afficherFrame frmAttente
  update idletasks
#  msgBox "ici"
#  update
}
# mise  jour de son message
proc majMsgAttente {libelle} {
  .frmAttente.lblMessage configure -text $libelle
  update idletasks
#  update
}


proc afficherTopAttente {{msgEntete ""} {msgAttente ""} {couleurFond ""} {couleurTexte "#000000"}} {
  global PARAM
  global langueAffichage

  if {$msgEntete == ""} {
    if {$langueAffichage == "FR"} {
      set msgEntete "Chargement en cours...\nVeuillez patienter..."
    } else {
      set msgEntete "Data processing...\nPlease wait..."
    }
  }
  if {$langueAffichage == "FR"} {
    set titre "Veuillez patienter..."
  } else {
    set titre "Please wait..."
  }
  if {$couleurFond == ""} {
    if {$PARAM(machine) == "PPC"} {
      set couleurFond "#FFFFFF"
    } else {
      set couleurFond "#bcbcbc"
    }
  }
destroy .frmTopAttente
  toplevel .frmTopAttente -background $couleurFond
wm overrideredirect .frmTopAttente true
  ajouterLigneVideHaut frmTopAttente $couleurFond
  ajouterLigneVideBas frmTopAttente $couleurFond
  ajouterFrame frmTopAttente frmAttente $couleurFond
  label .frmTopAttente.frmAttente.lblAttente -background $couleurFond -text $msgEntete -foreground $couleurTexte
  pack .frmTopAttente.frmAttente.lblAttente -expand 1 -fill x -padx 5

  if {$msgAttente != ""} {
    label .frmTopAttente.frmAttente.lblMessage -background $couleurFond -text $msgAttente -foreground $couleurTexte
    pack .frmTopAttente.frmAttente.lblMessage -side bottom -expand 1 -fill x -padx 5
  }
  
  wm title .frmTopAttente [replaceAll "$titre" "\n" " "]
#  wm iconify .frmTopAttente
  wm transient .frmTopAttente "."
  set haut [expr int($PARAM(hauteur) / 2)]
  set larg [expr int($PARAM(largeur) / 2)]
  # on la met carre :
  if {$haut > $larg} {
    set haut $larg
  } else {
    set larg $haut
  }
#  pause 3000
#  wm geometry .frmTopAttente "$larg\x$haut"
  #centrerTopLevel .frmTopAttente
  #wm state .frmTopAttente normal
#  pause 3000
  #wm transient .frmTopAttente "."
  centrerTopLevel .frmTopAttente true
#wm overrideredirect .frmTopAttente true

  focus -force .frmTopAttente
  update ;#idletasks
}

proc effacerTopAttente {} {
  destroy .frmTopAttente
  focus -force .
  update idletasks
}

### Affichage d'une bote de message
# Types autoriss : abortretryignore, ok, okcancel, retrycancel, yesno et yesnocancel
# Icones autoriss : error, info, question et warning
proc msgBox {message {titre ""} {type "ok"} {icone ""}} {
  global PARAM
  if {$titre == ""} {
    set titre $PARAM(nomAppli)
  }
  if {$icone != ""} {
    tk_messageBox -icon $icone -title [replaceAll "$titre" "\n" " "] -message "$message" -type $type
  } else {
    tk_messageBox -title [replaceAll "$titre" "\n" " "] -message "$message" -type $type
  }
}

proc estToucheEntree {k K} {
  # Le code de la touche entre n'est pas le meme entre Windows et Linux...
  # Windows : %k=13 et %K=Return
  # Linux   : %k=36 et %K=Return (touche 13=apostrophe)
  # WinCE   : (il me semble) %k=13 et %K!=Return
  # Mac     : ?
  if {("$k"=="13" && "$K" != "apostrophe") || ("$K" == "Return")} {
    return true
  } else {
    return false
  }
}

### Demande d'une info  l'utilisateur :
global valideInputBox
global reponseInputBox
set valideInputBox "..."
proc inputBox {listeLibelles {titre ""} {reponseDefaut ""}  {couleurFond ""} {avecAnnuler true} {frmMaster "."}} {
  global valideInputBox
  global reponseInputBox
  global PARAM
  global langueAffichage

  destroy .frmInput
  toplevel .frmInput
wm overrideredirect .frmInput true ;# on la "masque" pour viter le flash le temps de la positionner au milieu
  if {$titre == ""} {
    set titre "$PARAM(nomAppli)"
  }
  wm title .frmInput [replaceAll "$titre" "\n" " "]
  if {$frmMaster != ""} {
    wm transient .frmInput $frmMaster ;# On lie la fentre  la fentre frmMaster
  }
#  wm iconify .frmInput
  if {$couleurFond != ""} {
    .frmInput configure -background $couleurFond
  }
# gestionDragDropTopLevel .frmInput
  if {$PARAM(machine) != "PPC"} {
    catch "wm iconbitmap .frmInput $PARAM(icone)" ;# On y met l'icne de l'appli
  }

#  if {$PARAM(machine) == "PPC"} {
#    wce sipshow ;# affiche le clavier sur le PPC
#  }
afficherClavier

  set i 0
  label .frmInput.lblVide-1 -text ""
  if {$couleurFond != ""} {
    .frmInput.lblVide-1 configure -background $couleurFond
  }
  pack .frmInput.lblVide-1

  foreach libelle $listeLibelles {
    frame .frmInput.frmLibChamps$i
    if {$couleurFond != ""} {
      .frmInput.frmLibChamps$i configure -background $couleurFond
    }
    pack configure .frmInput.frmLibChamps$i ;#-expand 1 -fill x

    set reponseInputBox($i) [lindex $reponseDefaut $i]
    label .frmInput.frmLibChamps$i.lblDemande$i -text "$libelle"
    if {$couleurFond != ""} {
      .frmInput.frmLibChamps$i.lblDemande$i configure -background $couleurFond
    }
    entry .frmInput.frmLibChamps$i.txtReponse$i -textvariable reponseInputBox($i)
    bind .frmInput.frmLibChamps$i.txtReponse$i <KeyRelease> {+if {[estToucheEntree "%k" "%K"]} {.frmInput.frmBouttons.cmdValider invoke}}
    pack .frmInput.frmLibChamps$i.lblDemande$i .frmInput.frmLibChamps$i.txtReponse$i -side left

    label .frmInput.lblVide$i -text ""
    if {$couleurFond != ""} {
      .frmInput.lblVide$i configure -background $couleurFond
    }
    pack .frmInput.lblVide$i
    incr i
  }
  frame .frmInput.frmBouttons
  if {$couleurFond != ""} {
    .frmInput.frmBouttons configure -background $couleurFond
  }
  pack .frmInput.frmBouttons

  set libValider "Valider"
  if {$langueAffichage != "FR"} {
    set libValider "Ok"
  }
  button .frmInput.frmBouttons.cmdValider -text "$libValider" -command {set valideInputBox "ok";destroy .frmInput}
  if {$couleurFond != ""} {
    .frmInput.frmBouttons.cmdValider configure -background $couleurFond -activebackground $couleurFond
  }
  pack .frmInput.frmBouttons.cmdValider -side left -padx 6 -pady 6

  if {$avecAnnuler} {
    set libAnnuler "Annuler"
    if {$langueAffichage != "FR"} {
      set libAnnuler "Cancel"
    }
    button .frmInput.frmBouttons.cmdAnnuler -text "$libAnnuler" -command {set valideInputBox "ko";destroy .frmInput}
    if {$couleurFond != ""} {
      .frmInput.frmBouttons.cmdAnnuler configure -background $couleurFond -activebackground $couleurFond
    }
    pack .frmInput.frmBouttons.cmdAnnuler -side left -padx 6 -pady 6
  }

#  wm state .frmInput normal
  centrerTopLevel .frmInput
  focus .frmInput

  focus .frmInput.frmLibChamps0.txtReponse0
  .frmInput.frmLibChamps0.txtReponse0 selection range 0 end
  tkwait window .frmInput ;# On attend la fermeture de la fentre...
#  if {$PARAM(machine) == "PPC"} {
#    wce siphide ;# "referme" le clavier sur le PPC
#  }
refermerClavier
  if {$valideInputBox == "ok"} {
    if {$i == 1} {
      return $reponseInputBox(0)
    } else {
      set listeReponsesInputBox [list]
      for {set j 0} {$j < $i} {incr j} {
        lappend listeReponsesInputBox $reponseInputBox($j)
      }
      return $listeReponsesInputBox
    }
  } else {
    return ""
  }
}


###  Affichage d'une info  l'utilisateur
###   + demande d'une rponse de sa part, avec des boutons dont les libells sont paramtrables
global reponseDialogBox
set reponseDialogBox "..."
proc initDialogBox {titre couleurFond {gestionDragDrop true} {frmMaster "."}} {
  global PARAM

  destroy .frmDialog
  toplevel .frmDialog
wm overrideredirect .frmDialog true ;# on la "masque" pour viter le flash le temps de la positionner au milieu
  wm title .frmDialog [replaceAll "$titre" "\n" " "]
  if {$frmMaster != ""} {
    wm transient .frmDialog $frmMaster
  }
#  wm iconify .frmDialog
  if {$couleurFond != ""} {
    .frmDialog configure -background $couleurFond
  }
  if {$gestionDragDrop} {
    gestionDragDropTopLevel .frmDialog
  }
  if {$PARAM(machine) != "PPC"} {
    catch "wm iconbitmap .frmDialog $PARAM(icone)" ;# On y met l'icne de l'appli
  }
}
proc dialogBox {listeLibelles listeBouttons {policeLibelle ""} {policeBouttons ""} {couleurPoliceLibelle ""} {couleurPoliceBouttons ""} {couleurFond ""} {couleurFondLibelle ""} {couleurFondBouttons ""} {titre "Sans titre"} {frmMaster "."} {pourcWrap 80} {gestionDragDrop true}} {
  global reponseDialogBox
  global PARAM
global idDraggedObject

set idDraggedObject "" ;# Correction d'un bug : on doit rinitialiser idDraggedObject

  if {$listeLibelles == ".frmDialog.frmAffiche"} {
    pack $listeLibelles -expand 1 -fill x
  } else {
    initDialogBox $titre $couleurFond $gestionDragDrop $frmMaster
    set indLibelle 0
    foreach libelle $listeLibelles {
      label .frmDialog.lbl$indLibelle -text "$libelle" -justify "left" \
            -wraplength [expr int($PARAM(largeur) * $pourcWrap / 100)]
      if {$policeLibelle != ""} {
        .frmDialog.lbl$indLibelle configure -font $policeLibelle
      }
      if {$couleurPoliceLibelle != ""} {
        .frmDialog.lbl$indLibelle configure -foreground $couleurPoliceLibelle
      }
      if {$couleurFondLibelle != ""} {
        .frmDialog.lbl$indLibelle configure -background $couleurFondLibelle
      }
      pack .frmDialog.lbl$indLibelle -expand 1 -fill x
      incr indLibelle
    }
  }

  frame .frmDialog.frmBouttons
  if {$couleurFond != ""} {
    .frmDialog.frmBouttons configure -background $couleurFond
  }
  pack .frmDialog.frmBouttons
  set indBoutton 0
  foreach boutton $listeBouttons {
    button .frmDialog.frmBouttons.cmd$indBoutton -text "$boutton" -command "set reponseDialogBox $indBoutton;destroy .frmDialog" \
                                     -padx 2 -pady 2
    if {$policeBouttons != ""} {
      .frmDialog.frmBouttons.cmd$indBoutton configure -font $policeBouttons
    }
    if {$couleurPoliceBouttons != ""} {
      .frmDialog.frmBouttons.cmd$indBoutton configure -foreground $couleurPoliceBouttons -activeforeground $couleurPoliceBouttons
    }
    if {$couleurFondBouttons != ""} {
      .frmDialog.frmBouttons.cmd$indBoutton configure -background $couleurFondBouttons -activebackground $couleurFondBouttons
    }

    pack .frmDialog.frmBouttons.cmd$indBoutton -side left -padx 6 -pady 6
    incr indBoutton
  }

  wm state .frmDialog normal
  centrerTopLevel .frmDialog
  focus .frmDialog
  set reponseDialogBox ""
  tkwait window .frmDialog ;# On attend la fermeture de la fentre
  return $reponseDialogBox
}


### Slection d'une couleur :
global colorHexa
set colorHexa ""
global repCouleur
set repCouleur ""
global choixCouleur
set choixCouleur(Rouge) "0"
set choixCouleur(Vert) "0"
set choixCouleur(Bleu) "0"
proc choisirCouleur {{couleurInit "#000000"} {frmMaster "."}} {
  # Inspir de http://www.csc.calpoly.edu/~dbutler/tutorials/winter96/tcl/
  global colorHexa
  global repCouleur
  global PARAM
  global choixCouleur
  global langueAffichage

  set colorHexa ""

  destroy frmChoisirCouleur
  toplevel .frmChoisirCouleur
wm overrideredirect .frmChoisirCouleur true ;# on la "masque" pour viter le flash le temps de la positionner au milieu
  set titre "Couleur"
  if {$langueAffichage != "FR"} {
    set titre "Color"
  }
  wm title .frmChoisirCouleur [replaceAll "$titre" "\n" " "]
#  wm iconify .frmChoisirCouleur
#  gestionDragDropTopLevel .frmChoisirCouleur
  if {$PARAM(machine) != "PPC"} {
    catch "wm iconbitmap .frmChoisirCouleur $PARAM(icone)" ;# On y met l'icne de l'appli
  }
# Pour rester toujours au premier plan :
# wm attributes .frmChoisirCouleur -topmost true
# Pour apparatre au-dessus d'une autre (master) quand l'autre a le focus :
# wm transient .frm .autre

  set choixCouleurRouge 0
  if {$couleurInit != ""} {
    set choixCouleur(Rouge) [hex2dec [string range $couleurInit 1 2]]
    set choixCouleur(Vert) [hex2dec [string range $couleurInit 3 4]]
    set choixCouleur(Bleu) [hex2dec [string range $couleurInit 5 6]]
  }
  
  set libRouge "R"
  set libVert "V"
  set libBleu "B"
  if {$langueAffichage != "FR"} {
    set libVert "G"
  }


  frame .frmChoisirCouleur.frmRouge
  pack configure .frmChoisirCouleur.frmRouge -expand 1 -fill x
  label .frmChoisirCouleur.frmRouge.lblRouge -text "$libRouge"
  scale .frmChoisirCouleur.frmRouge.scaleRouge -from 0 -to 255 -orient horizontal -variable choixCouleur(Rouge) ; # -length 7c;
  pack .frmChoisirCouleur.frmRouge.lblRouge .frmChoisirCouleur.frmRouge.scaleRouge -side left

  frame .frmChoisirCouleur.frmVert
  pack configure .frmChoisirCouleur.frmVert -expand 1 -fill x
  label .frmChoisirCouleur.frmVert.lblVert -text "$libVert"
  scale .frmChoisirCouleur.frmVert.scaleVert -from 0 -to 255 -orient horizontal -variable choixCouleur(Vert) ; # -length 7c;
  pack .frmChoisirCouleur.frmVert.lblVert .frmChoisirCouleur.frmVert.scaleVert -side left

  frame .frmChoisirCouleur.frmBleu
  pack configure .frmChoisirCouleur.frmBleu -expand 1 -fill x
  label .frmChoisirCouleur.frmBleu.lblBleu -text "$libBleu"
  scale .frmChoisirCouleur.frmBleu.scaleBleu -from 0 -to 255 -orient horizontal -variable choixCouleur(Bleu) ; # -length 7c;
  pack .frmChoisirCouleur.frmBleu.lblBleu .frmChoisirCouleur.frmBleu.scaleBleu -side left

  set commandeScales {set colorHexa [format #%02x%02x%02x [.frmChoisirCouleur.frmRouge.scaleRouge get] [.frmChoisirCouleur.frmVert.scaleVert get] [.frmChoisirCouleur.frmBleu.scaleBleu get]]
                      .frmChoisirCouleur.cnvApercuCouleur config -background $colorHexa; #}
  .frmChoisirCouleur.frmRouge.scaleRouge configure -command $commandeScales
  .frmChoisirCouleur.frmVert.scaleVert configure -command $commandeScales
  .frmChoisirCouleur.frmBleu.scaleBleu configure -command $commandeScales

  entry .frmChoisirCouleur.txtColorHexa -width 7 -exportselection true -textvariable colorHexa -state readonly
  pack .frmChoisirCouleur.txtColorHexa

  canvas .frmChoisirCouleur.cnvApercuCouleur -width 1.5c -height 1.5c
  pack .frmChoisirCouleur.cnvApercuCouleur; # -side bottom -pady 2m

  frame .frmChoisirCouleur.frmBoutons
  pack configure .frmChoisirCouleur.frmBleu -expand 1 -fill x
  button .frmChoisirCouleur.cmdValider -text "Ok" -command {set repCouleur $colorHexa;destroy .frmChoisirCouleur}
  set libAnnuler "Annuler"
  if {$langueAffichage != "FR"} {
    set libAnnuler "Cancel"
  }
  button .frmChoisirCouleur.cmdAnnuler -text "$libAnnuler" -command {set repCouleur "";destroy .frmChoisirCouleur}
  pack .frmChoisirCouleur.cmdValider -side right
  pack .frmChoisirCouleur.cmdAnnuler -side left

  wm state .frmChoisirCouleur normal
  centrerTopLevel .frmChoisirCouleur
  focus .frmChoisirCouleur
  if {$frmMaster != ""} {
    wm transient .frmChoisirCouleur $frmMaster
  }

  # instruction dcouverte sur : http://www.lisi.ensma.fr/ftp/pub/documents/reports/1997/1997-LISI-97002.pdf
  tkwait window .frmChoisirCouleur
  return $repCouleur
}
