# Procdure permettant de remplacer toutes les occurences du caractre carCherche
# par la chaine chaineRemplace dans la chaine chaineDepart
# Retourne le resultat sous forme de chaine
proc replaceAll_anc {chaineDepart carCherche chaineRemplace} {
#logDebug "replaceAll $chaineDepart $carCherche $chaineRemplace"
  set liste [split $chaineDepart $carCherche]
  set res ""
  set premierPassage true
  foreach partie $liste {
#logDebug "    |$partie|"
#    if {$partie != ""} {
#      if {$res != ""} {
      if {!$premierPassage} {
        append res "$chaineRemplace"
      }
#      }
      append res "$partie"
      set premierPassage false
#    }
  }
  return $res
}

proc replaceAll {chaineDepart chaineCherchee chaineRemplace} {
set res ""
  if {[string match "*$chaineCherchee*" $chaineRemplace]} {
    # chaineRemplace contient chaineCherchee => risque de boucle infinie
    # => on effectue les replaces  la main :
set tailleCherchee [string length $chaineCherchee]
    set indTrouve 0 ;# pour rentrer ds la boucle
    set chaineDepartReste $chaineDepart
    while {$indTrouve >= 0} {
      set indTrouve [string first "$chaineCherchee" "$chaineDepartReste"]
      if {$indTrouve >= 0} {
        append res "[string range $chaineDepartReste 0 [expr {$indTrouve - 1}]]$chaineRemplace"
        set chaineDepartReste [string range $chaineDepartReste [expr {$indTrouve + $tailleCherchee}] end]
      } else {
        append res $chaineDepartReste
      }
    }
  } else {
if {[string length $chaineCherchee] == 1} {
return [replaceAllSingle $chaineDepart $chaineCherchee $chaineRemplace]
} else {
  set resPrec ""
  set res $chaineDepart
set tmp ""
if {"$chaineCherchee" == "-"} {
 set chaineCherchee {\-}
}
  while {$res != $resPrec} {
    regsub $chaineCherchee $res $chaineRemplace tmp
set resPrec $res
set res $tmp
  }
  }
}
#msgBox "$chaineDepart $chaineCherchee $chaineRemplace = $res"
  return $res
}


proc replaceAllSingle {chaineDepart carCherche chaineRemplace} {
  set liste [split $chaineDepart $carCherche]
  return [liste2chaine $liste $chaineRemplace]
}


# Fonction permettant de savoir si la chane passe en paramtre 
# reprsente un nombre entier ( >= nbMin et/ou <= nbMax ) ou non
# Retourne un message d'erreur (selon nomChamp) si ce n'est pas le cas ;
#          "" sinon !
proc testerFormatEntier {chaine nomChamp {nbMin ""} {nbMax ""}} {
  set msgErr ""
  set estEntier [regexp {^[0-9]+$} "$chaine"]
  if {$estEntier} {
    if {$nbMin != "" || $nbMax != ""} {
      set nb [expr {0 + $chaine}]
      if {$nbMin != ""} {
        if {$nb < $nbMin} {
          set msgErr "$nomChamp doit tre >= $nbMin"
        }
      }
      if {$nbMax != ""} {
        if {$nb > $nbMax} {
          set msgErr "$nomChamp doit tre <= $nbMax"
        }
      }
    }
  } else {
    set msgErr "$nomChamp doit tre un nombre entier..."
  }
  return $msgErr
}

# Fonction permettant de rcuprer 
# une lettre en minuscule sans accent
proc minusculeSansAccent {lettre} {
  set lettre [string tolower $lettre]
  set accents    [list                         ]
  set sansAccent [list a a a a a c e e e e i i i i n o o o o o u u u u y]
  set indice [lsearch $accents $lettre]
  if {$indice >= 0} {
    set lettre [lindex $sansAccent $indice]
  }
  return $lettre
}

# Suppresion des accents dans une chane
proc sansAccent {chaine {cherche ""} {remplace "AAAAAACEEEEIIIIOOOOOUUUUNaaaaaaceeeeiiiiooooouuuuyn"}} {
  set res "$chaine"
  if {$chaine != "" && $cherche != ""} {
    set longueur [string length $cherche]
    if {$longueur == [string length $remplace]} {
      set res "$chaine"
      # On parcourt la liste :
      set indCarCherche 0
      while {$indCarCherche < $longueur} {
        set res [replaceAll "$res" "[string range $cherche $indCarCherche $indCarCherche]" "[string range $remplace $indCarCherche $indCarCherche]"]
        incr indCarCherche
      }
    } else {
      logError "Lib_outils.sansAccent : cherche ($cherche) et remplace ($remplace) n'ont pas la mme longueur..."
      msgBox "Erreur lors de l'appel  Lib_outils.sansAccent (voir les logs)..."
    }
  }
#logDebug "sansAccent : chaine=$chaine => res=$res"
  return $res
}

# Mthodes permettant de savoir si un nombre est pair ou impair (ici, par convention, 0 est considr pair)
proc pair {nombre} {
  if {[expr $nombre % 2] == 0} {
    return true
  } else {
    return false
  }
}
proc impair {nombre} {
  return ! [pair $nombre]
}

proc hex2dec {nbHex} {
  set i 0
  set res 0
  set facteur 1
  set taille [string length $nbHex]
  while {$i < $taille} {
    set car [string tolower [string range $nbHex end-$i end-$i]]
    if {$car == "a"} {set car 10}
    if {$car == "b"} {set car 11}
    if {$car == "c"} {set car 12}
    if {$car == "d"} {set car 13}
    if {$car == "e"} {set car 14}
    if {$car == "f"} {set car 15}
    incr res [expr {$car * $facteur}]
    set facteur [expr {$facteur * 16}]
    incr i
  }
  return $res
}

proc liste2chaine {liste {separateur " "}} {
  set ret ""
  set i 0
  foreach elmt $liste {
    if {$i > 0} {
      append ret $separateur
    }
    append ret $elmt
    incr i
  }
  return $ret
}

proc globaleExiste {nomVar} {
  catch {global $nomVar}
  return [info exists $nomVar]
}


