#########################################
# Librairie de gestion des statistiques #
#########################################

global statistiques ;# Dclaration du tableau global
global ficStatsCourant
set ficStatsCourant [cheminComplet "statistiques.txt"]

global txt
set txt(TXT_PAS_STATS) "Aucune statistique pour le moment..."
set txt(TXT_FERMER_STATS) "Fermer"
set txt(TXT_VIDER_STATS) "Effacer les stats"
set txt(TXT_DDE_VIDER_STATS) "tes-vous sr de vouloir vider les statistiques ?"
set txt(TITRE_DEFAUT_STATS) "Statistiques"
set txt(TITRE_VIDER_STATS) "Effacer"

global NB_LIGNES_MAX
set NB_LIGNES_MAX 20
	
global couleurs
set couleurs(StatsFondFenetre) "#ffffff"
set couleurs(StatsFondLibelle) $couleurs(StatsFondFenetre)
set couleurs(StatsFondBouttons) $couleurs(StatsFondFenetre)
set couleurs(StatsPoliceTitre) "#000000"
set couleurs(StatsPoliceLibelle) ""
set couleurs(StatsPoliceBouttons) ""

# On excute le fichier des paramtres, selon la machine,
# pour mettre  jour les polices et couleurs des statistiques :
global PARAM
global polices
source "initParamsInterface_$PARAM(machine)\.ini"

set polices(StatsLib) [font create -family Courier -size $PARAM(taillePoliceBase) -weight bold -slant italic]
set polices(StatsBouttons) ""
set polices(StatsTitre) [font create -family Courier -size [expr {$PARAM(taillePoliceBase) + 3}] -weight bold -underline true]
set polices(StatsLibStats) [font create -family Courier -size $PARAM(taillePoliceBase)]


# Affichage de la bote de dialogue des statistiques
proc afficherStats {{titre ""} {frmMaster "."}} {
  global statistiques
  global NB_LIGNES_MAX
  global polices
  global couleurs
  global txt

  if {$titre == ""} {
    set titre $txt(TITRE_DEFAUT_STATS)
  }
  initDialogBox $titre $couleurs(StatsFondFenetre)

  if {$couleurs(StatsFondLibelle) == ""} {
    set couleurs(StatsFondLibelle) $couleurs(StatsFondFenetre)
  }
  if {$couleurs(StatsPoliceLibelle) == ""} {
    set couleurs(StatsPoliceLibelle) "#000000"
  }

  frame .frmDialog.frmAffiche -background $couleurs(StatsFondFenetre)
catch {grid anchor .frmDialog.frmAffiche center}

  set nbStats [tailleStats]
    set nbParLigne [expr 1 + int($nbStats / ($NB_LIGNES_MAX + 1))]
    set nbCols [expr {$nbParLigne * 2}]

    set ligne 1
    set colonne 0

    label .frmDialog.frmAffiche.lblVideAvantTitre -text "" -background $couleurs(StatsFondFenetre) \
       -font $polices(StatsLib)
    grid .frmDialog.frmAffiche.lblVideAvantTitre -row [incr ligne] -column 1

    label .frmDialog.frmAffiche.lblTitre -text "$titre" -background $couleurs(StatsFondLibelle) \
       -font $polices(StatsTitre) -foreground $couleurs(StatsPoliceTitre)
    grid .frmDialog.frmAffiche.lblTitre -row [incr ligne] -column 1 -padx 5 -columnspan $nbCols

    label .frmDialog.frmAffiche.lblVideApresTitre -text "" -background $couleurs(StatsFondFenetre) \
       -font $polices(StatsLib) -foreground $couleurs(StatsPoliceLibelle)
    grid .frmDialog.frmAffiche.lblVideApresTitre -row [incr ligne] -column 1

  if {$nbStats > 0} {
    set listeStats [lsort [array names statistiques]]


    set i 0
    while {$i < $nbStats} {
      # on crit chaque ligne :
      incr ligne
      for {set j 1} {$j <= $nbParLigne} {incr j} {
        if {$i < $nbStats} {
          # il en reste :
          set nom [lindex $listeStats $i]
          set stat $statistiques($nom)
#          append ligne "$nom : $stat  "

          label .frmDialog.frmAffiche.lblNomStat_$ligne\_$colonne -text "$nom : " -background $couleurs(StatsFondLibelle) \
             -font $polices(StatsLib) -foreground $couleurs(StatsPoliceLibelle)
          grid .frmDialog.frmAffiche.lblNomStat_$ligne\_$colonne -row $ligne -column [incr colonne] -sticky e

          label .frmDialog.frmAffiche.lblStat_$ligne\_$colonne -text "$stat   " -background $couleurs(StatsFondLibelle) \
             -font $polices(StatsLibStats) -foreground $couleurs(StatsPoliceLibelle)
          grid .frmDialog.frmAffiche.lblStat_$ligne\_$colonne -row $ligne -column [incr colonne] -sticky e

          incr i
        }
      }
      set colonne 0
    }
  } else {
    label .frmDialog.frmAffiche.lblAucuneStat -text " $txt(TXT_PAS_STATS) " -background $couleurs(StatsFondLibelle) \
       -font $polices(StatsLib) -foreground $couleurs(StatsPoliceLibelle)
    grid .frmDialog.frmAffiche.lblAucuneStat -row [incr ligne] -column 1
  }
  label .frmDialog.frmAffiche.lblVideApresStat -text "" -background $couleurs(StatsFondFenetre) \
     -font $polices(StatsLib) -foreground $couleurs(StatsPoliceLibelle)
  grid .frmDialog.frmAffiche.lblVideApresStat -row [incr ligne] -column 1

  set repAffichage [dialogBox ".frmDialog.frmAffiche" [list "$txt(TXT_FERMER_STATS)" "$txt(TXT_VIDER_STATS)"] \
                              $polices(StatsLib) $polices(StatsBouttons) \
                              $couleurs(StatsPoliceLibelle) $couleurs(StatsPoliceBouttons) \
                              $couleurs(StatsFondFenetre) $couleurs(StatsFondLibelle) $couleurs(StatsFondBouttons) \
                              $titre "" 100]
  if {$repAffichage == 1 && $nbStats > 0} {
    # Clic sur "effacer" => on efface !
      viderStats
  }

}

# Mthode permettant d'effacer les stats, aprs confirmation
proc viderStats {{ddeConfirm true}} {
  global statistiques 
  global ficStatsCourant
  global txt

  set ok "yes"
  if {$ddeConfirm} {
    set ok [msgBox "$txt(TXT_DDE_VIDER_STATS)" "$txt(TITRE_VIDER_STATS)" "yesno"]
  }
  if {$ok == "yes"} {
    # On fait une sauvegarde, au cas o...
    set sauvNomFic $ficStatsCourant
    sauverStats "$ficStatsCourant\_sauv.txt"
    unset statistiques
ecrireFichier $sauvNomFic "" 1
#    sauverStats $sauvNomFic
  }
}

# Chargement des stats contenues dans le fichier spcifi
proc chargerStats {{fichier ""}} {
  global statistiques
  global ficStatsCourant

  if {$fichier != ""} {
    set ficStatsCourant $fichier
  }
  catch {unset statistiques}
  if {[array size statistiques] <= 0} {
    catch {chargerGlobales $ficStatsCourant}
  }
}

# Sauvegarde des stats dans le fichier spcifi
proc sauverStats {{fichier ""}} {
  global statistiques
  global ficStatsCourant

  if {$fichier != ""} {
    set ficStatsCourant $fichier
  }
  catch {sauverGlobales $ficStatsCourant statistiques}
}

# Calcul de la taille du tableau des stats
proc tailleStats {} {
  global statistiques

  return [array size statistiques]
}

# Incrmentation des stats 
proc incrementerStats {nom {sauverAuto true} {increment 1}} {
  global statistiques

  set existeDeja [existeStats $nom]
  if {! $existeDeja} {
    creerStats $nom
  }
  set statistiques($nom) [expr {$statistiques($nom) + $increment}]
  if {$sauverAuto} {
    sauverStats ;# Et on sauve !
  }
}

# Existe-t-il des stats pour ce nom ?
proc existeStats {nom} {
  global statistiques

  return [expr [lsearch [array names statistiques] $nom] >= 0]
}

# Rcupration des stats pour ce nom
proc getStats {nom} {
  global statistiques

  creerStats $nom ;# on les cre au cas o... 
  return $statistiques($nom)
}

# Cration de stats pour le nom donn :
proc creerStats {nom} {
  global statistiques

  if {! [existeStats $nom]} {
    set statistiques($nom) 0
  }
}

chargerStats ;# Ds le chargement, on charge les stats